package com.simibubi.create.compat.rei;

import java.util.Arrays;
import java.util.stream.Stream;
import net.minecraft.class_1767;
import net.minecraft.class_1769;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_1867;
import net.minecraft.class_2248;
import net.minecraft.class_2371;
import net.minecraft.class_2960;
import net.minecraft.class_3955;
import net.minecraft.class_6862;
import net.minecraft.class_7710;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.Create;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.ItemValueAccessor;
import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.TagValueAccessor;

public final class ToolboxColoringRecipeMaker {

	// From JEI's ShulkerBoxColoringRecipeMaker
	public static Stream<class_3955> createRecipes() {
		String group = "create.toolbox.color";
		class_1799 baseShulkerStack = AllBlocks.TOOLBOXES.get(class_1767.field_7957)
			.asStack();
		class_1856 baseShulkerIngredient = class_1856.method_8101(baseShulkerStack);

		return Arrays.stream(class_1767.values())
			.filter(dc -> dc != class_1767.field_7957)
			.map(color -> {
				class_1769 dye = class_1769.method_7803(color);
				class_1799 dyeStack = new class_1799(dye);
				class_6862<class_1792> colorTag = color.getTag();
				class_1856.class_1859 dyeList = ItemValueAccessor.createItemValue(dyeStack);
				class_1856.class_1859 colorList = TagValueAccessor.createTagValue(colorTag);
				Stream<class_1856.class_1859> colorIngredientStream = Stream.of(dyeList, colorList);
				class_1856 colorIngredient = class_1856.method_8092(colorIngredientStream);
				class_2371<class_1856> inputs =
					class_2371.method_10212(class_1856.field_9017, baseShulkerIngredient, colorIngredient);
				class_2248 coloredShulkerBox = AllBlocks.TOOLBOXES.get(color)
					.get();
				class_1799 output = new class_1799(coloredShulkerBox);
				class_2960 id = Create.asResource(group + "." + output.method_7922());
				return new class_1867(id, group, class_7710.field_40251, output, inputs);
			});
	}

	private ToolboxColoringRecipeMaker() {}

}
