package com.simibubi.create.compat.rei.category;

import org.jetbrains.annotations.NotNull;
import com.simibubi.create.compat.rei.category.animations.AnimatedKinetics;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import net.minecraft.class_1874;
import net.minecraft.class_332;
import net.minecraft.class_3612;

public class FanBlastingCategory extends ProcessingViaFanCategory<class_1874> {

	public FanBlastingCategory(Info<class_1874> info) {
		super(info);
	}

	@Override
	protected AllGuiTextures getBlockShadow() {
		return AllGuiTextures.JEI_LIGHT;
	}

	@Override
	protected void renderAttachedBlock(@NotNull class_332 graphics) {
		GuiGameElement.of(class_3612.field_15908)
			.scale(SCALE)
			.atLocal(0, 0, 2)
			.lighting(AnimatedKinetics.DEFAULT_LIGHTING)
			.render(graphics);
	}

}
