package com.simibubi.create.compat.rei.category.animations;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.deployer.DeployerBlock;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class AnimatedDeployer extends AnimatedKinetics {

	@Override
	public void draw(class_332 graphics, int xOffset, int yOffset) {
		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(xOffset, yOffset, 100);
		matrixStack.method_22907(net.minecraft.class_7833.field_40714.rotationDegrees(-15.5f));
		matrixStack.method_22907(net.minecraft.class_7833.field_40716.rotationDegrees(22.5f));
		int scale = 20;

		blockElement(shaft(class_2351.field_11051))
			.rotateBlock(0, 0, getCurrentAngle())
			.scale(scale)
			.render(graphics);

		blockElement(AllBlocks.DEPLOYER.getDefaultState()
			.method_11657(DeployerBlock.FACING, class_2350.field_11033)
			.method_11657(DeployerBlock.AXIS_ALONG_FIRST_COORDINATE, false))
			.scale(scale)
			.render(graphics);

		float cycle = (AnimationTickHolder.getRenderTime() - offset * 8) % 30;
		float offset = cycle < 10 ? cycle / 10f : cycle < 20 ? (20 - cycle) / 10f : 0;

		matrixStack.method_22903();

		matrixStack.method_46416(0, offset * 17, 0);
		blockElement(AllPartialModels.DEPLOYER_POLE)
			.rotateBlock(90, 0, 0)
			.scale(scale)
			.render(graphics);
		blockElement(AllPartialModels.DEPLOYER_HAND_HOLDING)
			.rotateBlock(90, 0, 0)
			.scale(scale)
			.render(graphics);

		matrixStack.method_22909();

		blockElement(AllBlocks.DEPOT.getDefaultState())
			.atLocal(0, 2, 0)
			.scale(scale)
			.render(graphics);

		matrixStack.method_22909();
	}

}
