package com.simibubi.create.content.contraptions;

import com.simibubi.create.foundation.networking.SimplePacketBase;

import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.minecraft.class_2338;
import net.minecraft.class_2512;
import net.minecraft.class_2540;
import net.minecraft.class_2680;
import net.minecraft.class_7923;

public class ContraptionBlockChangedPacket extends SimplePacketBase {

	int entityID;
	class_2338 localPos;
	class_2680 newState;

	public ContraptionBlockChangedPacket(int id, class_2338 pos, class_2680 state) {
		entityID = id;
		localPos = pos;
		newState = state;
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityID);
		buffer.method_10807(localPos);
		buffer.method_10794(class_2512.method_10686(newState));
	}

	@SuppressWarnings("deprecation")
	public ContraptionBlockChangedPacket(class_2540 buffer) {
		entityID = buffer.readInt();
		localPos = buffer.method_10811();
		newState = class_2512.method_10681(class_7923.field_41175.method_46771(), buffer.method_10798());
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT,
			() -> () -> AbstractContraptionEntity.handleBlockChangedPacket(this)));
		return true;
	}

}
