package com.simibubi.create.content.contraptions;

import java.util.Arrays;
import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import com.simibubi.create.content.equipment.goggles.IHaveGoggleInformation;
import com.simibubi.create.foundation.item.TooltipHelper;
import com.simibubi.create.foundation.item.TooltipHelper.Palette;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

public interface IDisplayAssemblyExceptions {

	default boolean addExceptionToTooltip(List<class_2561> tooltip) {
		AssemblyException e = getLastAssemblyException();
		if (e == null)
			return false;

		if (!tooltip.isEmpty())
			tooltip.add(Components.immutableEmpty());

		tooltip.add(IHaveGoggleInformation.componentSpacing.method_27662()
			.method_10852(Lang.translateDirect("gui.assembly.exception")
				.method_27692(class_124.field_1065)));

		String text = e.component.getString();
		Arrays.stream(text.split("\n"))
			.forEach(l -> TooltipHelper.cutStringTextComponent(l, Palette.GRAY_AND_WHITE)
				.forEach(c -> tooltip.add(IHaveGoggleInformation.componentSpacing.method_27662()
					.method_10852(c))));

		return true;
	}

	AssemblyException getLastAssemblyException();

}
