package com.simibubi.create.content.contraptions.bearing;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.foundation.block.IBE;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3965;

public class ClockworkBearingBlock extends BearingBlock implements IBE<ClockworkBearingBlockEntity> {

	public ClockworkBearingBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos,
			class_1657 player, class_1268 handIn, class_3965 hit) {
		if (!player.method_7294())
			return class_1269.field_5814;
		if (player.method_5715())
			return class_1269.field_5814;
		if (player.method_5998(handIn).method_7960()) {
			if (!worldIn.field_9236) {
				withBlockEntityDo(worldIn, pos, be -> {
					if (be.running) {
						be.disassemble();
						return;
					}
					be.assembleNextTick = true;
				});
			}
			return class_1269.field_5812;
		}
		return class_1269.field_5811;
	}

	@Override
	public Class<ClockworkBearingBlockEntity> getBlockEntityClass() {
		return ClockworkBearingBlockEntity.class;
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		class_1269 resultType = super.onWrenched(state, context);
		if (!context.method_8045().field_9236 && resultType.method_23665())
			withBlockEntityDo(context.method_8045(), context.method_8037(), ClockworkBearingBlockEntity::disassemble);
		return resultType;
	}

	@Override
	public class_2591<? extends ClockworkBearingBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.CLOCKWORK_BEARING.get();
	}

}
