package com.simibubi.create.content.contraptions.behaviour;

import org.apache.commons.lang3.tuple.MutablePair;

import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import net.minecraft.class_1268;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_2338;
import net.minecraft.class_3499.class_3501;

public abstract class MovingInteractionBehaviour {

	protected void setContraptionActorData(AbstractContraptionEntity contraptionEntity, int index,
		class_3501 info, MovementContext ctx) {
		contraptionEntity.getContraption().getActors().remove(index);
		contraptionEntity.getContraption().getActors().add(index, MutablePair.of(info, ctx));
		if (contraptionEntity.method_37908().field_9236)
			contraptionEntity.getContraption().deferInvalidate = true;
	}

	protected void setContraptionBlockData(AbstractContraptionEntity contraptionEntity, class_2338 pos,
		class_3501 info) {
		if (contraptionEntity.method_37908().method_8608())
			return;
		contraptionEntity.setBlock(pos, info);
	}

	public boolean handlePlayerInteraction(class_1657 player, class_1268 activeHand, class_2338 localPos,
		AbstractContraptionEntity contraptionEntity) {
		return true;
	}

	public void handleEntityCollision(class_1297 entity, class_2338 localPos, AbstractContraptionEntity contraptionEntity) {}

}
