package com.simibubi.create.content.contraptions.behaviour.dispenser;

import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1541;
import net.minecraft.class_156;
import net.minecraft.class_1671;
import net.minecraft.class_1676;
import net.minecraft.class_1677;
import net.minecraft.class_1686;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1826;
import net.minecraft.class_1844;
import net.minecraft.class_1847;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2263;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3481;
import net.minecraft.class_3486;
import net.minecraft.class_3730;
import net.minecraft.class_4481;
import net.minecraft.class_4482;
import net.minecraft.class_5819;

public interface IMovedDispenseItemBehaviour {

	static void initSpawnEggs() {
		final IMovedDispenseItemBehaviour spawnEggDispenseBehaviour = new MovedDefaultDispenseItemBehaviour() {
			@Override
			protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos, class_243 facing) {
				if (!(itemStack.method_7909() instanceof class_1826))
					return super.dispenseStack(itemStack, context, pos, facing);
				if (context.world instanceof class_3218) {
					class_1299<?> entityType = ((class_1826) itemStack.method_7909()).method_8015(itemStack.method_7969());
					class_1297 spawnedEntity = entityType.method_5894((class_3218) context.world, itemStack, null,
						pos.method_10081(class_2338.method_49637(facing.field_1352 + .7, facing.field_1351 + .7, facing.field_1350 + .7)), class_3730.field_16470, facing.field_1351 < .5,
						false);
					if (spawnedEntity != null)
						spawnedEntity.method_18799(context.motion.method_1021(2));
				}
				itemStack.method_7934(1);
				return itemStack;
			}
		};

		for (class_1826 spawneggitem : class_1826.method_8017())
			DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(spawneggitem, spawnEggDispenseBehaviour);
	}

	static void init() {
		MovedProjectileDispenserBehaviour movedPotionDispenseItemBehaviour = new MovedProjectileDispenserBehaviour() {
			@Override
			protected class_1676 getProjectileEntity(class_1937 world, double x, double y, double z, class_1799 itemStack) {
				return class_156.method_654(new class_1686(world, x, y, z), (p_218411_1_) -> p_218411_1_.method_16940(itemStack));
			}

			protected float getProjectileInaccuracy() {
				return super.getProjectileInaccuracy() * 0.5F;
			}

			protected float getProjectileVelocity() {
				return super.getProjectileVelocity() * .5F;
			}
		};

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8436,
			movedPotionDispenseItemBehaviour);
		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8150,
			movedPotionDispenseItemBehaviour);

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8626,
			new MovedDefaultDispenseItemBehaviour() {
				@Override
				protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos,
					class_243 facing) {
					double x = pos.method_10263() + facing.field_1352 * .7 + .5;
					double y = pos.method_10264() + facing.field_1351 * .7 + .5;
					double z = pos.method_10260() + facing.field_1350 * .7 + .5;
					class_1541 tntentity = new class_1541(context.world, x, y, z, null);
					tntentity.method_5762(context.motion.field_1352, context.motion.field_1351, context.motion.field_1350);
					context.world.method_8649(tntentity);
					context.world.method_43128(null, tntentity.method_23317(), tntentity.method_23318(), tntentity.method_23321(),
						class_3417.field_15079, class_3419.field_15245, 1.0F, 1.0F);
					itemStack.method_7934(1);
					return itemStack;
				}
			});

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8639,
			new MovedDefaultDispenseItemBehaviour() {
				@Override
				protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos,
					class_243 facing) {
					double x = pos.method_10263() + facing.field_1352 * .7 + .5;
					double y = pos.method_10264() + facing.field_1351 * .7 + .5;
					double z = pos.method_10260() + facing.field_1350 * .7 + .5;
					class_1671 fireworkrocketentity =
						new class_1671(context.world, itemStack, x, y, z, true);
					fireworkrocketentity.method_7485(facing.field_1352, facing.field_1351, facing.field_1350, 0.5F, 1.0F);
					context.world.method_8649(fireworkrocketentity);
					itemStack.method_7934(1);
					return itemStack;
				}

				@Override
				protected void playDispenseSound(class_1936 world, class_2338 pos) {
					world.method_20290(1004, pos, 0);
				}
			});

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8814,
			new MovedDefaultDispenseItemBehaviour() {
				@Override
				protected void playDispenseSound(class_1936 world, class_2338 pos) {
					world.method_20290(1018, pos, 0);
				}

				@Override
				protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos,
					class_243 facing) {
					class_5819 random = context.world.field_9229;
					double x = pos.method_10263() + facing.field_1352 * .7 + .5;
					double y = pos.method_10264() + facing.field_1351 * .7 + .5;
					double z = pos.method_10260() + facing.field_1350 * .7 + .5;
					context.world.method_8649(class_156.method_654(
						new class_1677(context.world, x, y, z,
							random.method_43059() * 0.05D + facing.field_1352 + context.motion.field_1352,
							random.method_43059() * 0.05D + facing.field_1351 + context.motion.field_1351,
							random.method_43059() * 0.05D + facing.field_1350 + context.motion.field_1350),
						(p_229425_1_) -> p_229425_1_.method_16936(itemStack)));
					itemStack.method_7934(1);
					return itemStack;
				}
			});

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8469,
			new MovedOptionalDispenseBehaviour() {
				@Override
				protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos,
					class_243 facing) {
					this.successful = false;
					class_2338 interactAt = pos.method_10093(getClosestFacingDirection(facing));
					class_2680 state = context.world.method_8320(interactAt);
					class_2248 block = state.method_26204();

					if (state.method_26164(class_3481.field_20340) && state.method_11654(class_4481.field_20420) >= 5) {
						((class_4481) block).method_21841(context.world, state, interactAt, null,
							class_4482.class_4484.field_20429);
						this.successful = true;
						return placeItemInInventory(itemStack, new class_1799(class_1802.field_20417), context, pos, facing);
					} else if (context.world.method_8316(interactAt)
						.method_15767(class_3486.field_15517)) {
						this.successful = true;
						return placeItemInInventory(itemStack,
							class_1844.method_8061(new class_1799(class_1802.field_8574), class_1847.field_8991), context, pos, facing);
					} else {
						return super.dispenseStack(itemStack, context, pos, facing);
					}
				}
			});

		DispenserMovementBehaviour.registerMovedDispenseItemBehaviour(class_1802.field_8550,
			new MovedDefaultDispenseItemBehaviour() {
				@Override
				protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos,
					class_243 facing) {
					class_2338 interactAt = pos.method_10093(getClosestFacingDirection(facing));
					class_2680 state = context.world.method_8320(interactAt);
					class_2248 block = state.method_26204();
					if (block instanceof class_2263) {
						class_1799 bucket = ((class_2263) block).method_9700(context.world, interactAt, state);
						return placeItemInInventory(itemStack, bucket, context, pos, facing);
					}
					return super.dispenseStack(itemStack, context, pos, facing);
				}
			});
	}

	class_1799 dispense(class_1799 itemStack, MovementContext context, class_2338 pos);
}
