package com.simibubi.create.content.contraptions.minecart.capability;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import io.github.fabricators_of_create.porting_lib.util.LazyOptional;
import io.github.fabricators_of_create.porting_lib.util.MinecartAndRailUtil;
import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1297;
import net.minecraft.class_1688;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import net.minecraft.class_638;

public class MinecartControllerUpdatePacket extends SimplePacketBase {

	int entityID;
	class_2487 nbt;

	public MinecartControllerUpdatePacket(MinecartController controller) {
		entityID = controller.cart()
			.method_5628();
		nbt = controller.serializeNBT();
	}

	public MinecartControllerUpdatePacket(class_2540 buffer) {
		entityID = buffer.readInt();
		nbt = buffer.method_10798();
	}

	@Override
	public void write(class_2540 buffer) {
 		buffer.writeInt(entityID);
		buffer.method_10794(nbt);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> this::handleCL));
		return true;
	}

	@Environment(EnvType.CLIENT)
	private void handleCL() {
		class_638 world = class_310.method_1551().field_1687;
		if (world == null)
			return;
		class_1297 entityByID = world.method_8469(entityID);
		if (entityByID == null)
			return;
		((class_1688) entityByID).create$getController().deserializeNBT(nbt);
	}

}
