package com.simibubi.create.content.equipment.blueprint;

import java.util.Collection;
import net.minecraft.class_1269;
import net.minecraft.class_1299;
import net.minecraft.class_1530;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1856;
import net.minecraft.class_1856.class_1857;
import net.minecraft.class_1856.class_1858;
import net.minecraft.class_1856.class_1859;
import net.minecraft.class_1860;
import net.minecraft.class_1869;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2960;
import net.minecraft.class_3518;
import net.minecraft.class_6862;
import net.minecraft.class_7924;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.logistics.filter.AttributeFilterMenu.WhitelistMode;
import com.simibubi.create.content.logistics.filter.FilterItem;
import com.simibubi.create.content.logistics.filter.ItemAttribute;

import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import io.github.fabricators_of_create.porting_lib.util.MultiItemValue;

public class BlueprintItem extends class_1792 {

	public BlueprintItem(class_1793 p_i48487_1_) {
		super(p_i48487_1_);
	}

	@Override
	public class_1269 method_7884(class_1838 ctx) {
		class_2350 face = ctx.method_8038();
		class_1657 player = ctx.method_8036();
		class_1799 stack = ctx.method_8041();
		class_2338 pos = ctx.method_8037()
				.method_10093(face);

		if (player != null && !player.method_7343(pos, face, stack))
			return class_1269.field_5814;

		class_1937 world = ctx.method_8045();
		class_1530 hangingentity = new BlueprintEntity(world, pos, face, face.method_10166()
				.method_10179() ? class_2350.field_11033 : ctx.method_8042());
		class_2487 compoundnbt = stack.method_7969();

		if (compoundnbt != null)
			class_1299.method_5881(world, player, hangingentity, compoundnbt);
		if (!hangingentity.method_6888())
			return class_1269.field_21466;
		if (!world.field_9236) {
			hangingentity.method_6894();
			world.method_8649(hangingentity);
		}

		stack.method_7934(1);
		return class_1269.method_29236(world.field_9236);
	}

	protected boolean canPlace(class_1657 p_200127_1_, class_2350 p_200127_2_, class_1799 p_200127_3_,
							   class_2338 p_200127_4_) {
		return p_200127_1_.method_7343(p_200127_4_, p_200127_2_, p_200127_3_);
	}

	public static void assignCompleteRecipe(class_1937 level, ItemStackHandler inv, class_1860<?> recipe) {
		class_2371<class_1856> ingredients = recipe.method_8117();

		for (int i = 0; i < 9; i++)
			inv.setStackInSlot(i, class_1799.field_8037);
		inv.setStackInSlot(9, recipe.method_8110(level.method_30349()));

		if (recipe instanceof class_1869) {
			class_1869 shapedRecipe = (class_1869) recipe;
			for (int row = 0; row < shapedRecipe.method_8158(); row++)
				for (int col = 0; col < shapedRecipe.method_8150(); col++)
					inv.setStackInSlot(row * 3 + col,
							convertIngredientToFilter(ingredients.get(row * shapedRecipe.method_8150() + col)));
		} else {
			for (int i = 0; i < ingredients.size(); i++)
				inv.setStackInSlot(i, convertIngredientToFilter(ingredients.get(i)));
		}
	}

	private static class_1799 convertIngredientToFilter(class_1856 ingredient) {
		class_1856.class_1859[] acceptedItems = ingredient.field_9019;
		if (acceptedItems == null || acceptedItems.length > 18)
			return class_1799.field_8037;
		if (acceptedItems.length == 0)
			return class_1799.field_8037;
		if (acceptedItems.length == 1)
			return convertIItemListToFilter(acceptedItems[0]);

		class_1799 result = AllItems.FILTER.asStack();
		ItemStackHandler filterItems = FilterItem.getFilterItems(result);
		for (int i = 0; i < acceptedItems.length; i++)
			filterItems.setStackInSlot(i, convertIItemListToFilter(acceptedItems[i]));
		result.method_7948()
				.method_10566("Items", filterItems.serializeNBT());
		return result;
	}

	private static class_1799 convertIItemListToFilter(class_1859 itemList) {
		Collection<class_1799> stacks = itemList.method_8108();
		if (itemList instanceof class_1857) {
			for (class_1799 itemStack : stacks)
				return itemStack;
		}

		if (itemList instanceof class_1858) {
			class_2960 resourcelocation = new class_2960(class_3518.method_15265(itemList.method_8109(), "tag"));
			class_1799 filterItem = AllItems.ATTRIBUTE_FILTER.asStack();
			filterItem.method_7948()
					.method_10569("WhitelistMode", WhitelistMode.WHITELIST_DISJ.ordinal());
			class_2499 attributes = new class_2499();
			ItemAttribute at = new ItemAttribute.InTag(class_6862.method_40092(class_7924.field_41197, resourcelocation));
			class_2487 compoundNBT = new class_2487();
			at.serializeNBT(compoundNBT);
			compoundNBT.method_10556("Inverted", false);
			attributes.add(compoundNBT);
			filterItem.method_7948()
					.method_10566("MatchedAttributes", attributes);
			return filterItem;
		}

		if (itemList instanceof MultiItemValue) {
			class_1799 result = AllItems.FILTER.asStack();
			ItemStackHandler filterItems = FilterItem.getFilterItems(result);
			int i = 0;
			for (class_1799 itemStack : stacks) {
				if (i >= 18)
					break;
				filterItems.setStackInSlot(i++, itemStack);
			}
			class_2487 tag = result.method_7948();
			tag.method_10566("Items", filterItems.serializeNBT());
			tag.method_10556("RespectNBT", true);
			return result;
		}

		return class_1799.field_8037;
	}

}
