package com.simibubi.create.content.equipment.extendoGrip;

import java.util.function.Supplier;
import net.minecraft.class_1268;
import net.minecraft.class_1297;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.fabric.ReachUtil;

public class ExtendoGripInteractionPacket extends SimplePacketBase {

	private class_1268 interactionHand;
	private int target;
	private class_243 specificPoint;

	public ExtendoGripInteractionPacket(class_1297 target) {
		this(target, null);
	}

	public ExtendoGripInteractionPacket(class_1297 target, class_1268 hand) {
		this(target, hand, null);
	}

	public ExtendoGripInteractionPacket(class_1297 target, class_1268 hand, class_243 specificPoint) {
		interactionHand = hand;
		this.specificPoint = specificPoint;
		this.target = target.method_5628();
	}

	public ExtendoGripInteractionPacket(class_2540 buffer) {
		target = buffer.readInt();
		int handId = buffer.readInt();
		interactionHand = handId == -1 ? null : class_1268.values()[handId];
		if (buffer.readBoolean())
			specificPoint = new class_243(buffer.readDouble(), buffer.readDouble(), buffer.readDouble());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(target);
		buffer.writeInt(interactionHand == null ? -1 : interactionHand.ordinal());
		buffer.writeBoolean(specificPoint != null);
		if (specificPoint != null) {
			buffer.writeDouble(specificPoint.field_1352);
			buffer.writeDouble(specificPoint.field_1351);
			buffer.writeDouble(specificPoint.field_1350);
		}
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			if (sender == null)
				return;
			class_1297 entityByID = sender.method_37908()
				.method_8469(target);
			if (entityByID != null && ExtendoGripItem.isHoldingExtendoGrip(sender)) {
				double d = ReachUtil.reach(sender);
				if (!sender.method_6057(entityByID))
					d -= 3;
				d *= d;
				if (sender.method_5858(entityByID) > d)
					return;
				if (interactionHand == null)
					sender.method_7324(entityByID);
				else if (specificPoint == null)
					sender.method_7287(entityByID, interactionHand);
				else
					entityByID.method_5664(sender, specificPoint, interactionHand);
			}
		});
		return true;
	}

}
