package com.simibubi.create.content.equipment.potatoCannon;

import com.jozufozu.flywheel.core.PartialModel;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.Create;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModel;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModelRenderer;
import com.simibubi.create.foundation.item.render.PartialItemModelRenderer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_1306;
import net.minecraft.class_1799;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_4608;
import net.minecraft.class_746;
import net.minecraft.class_7833;
import net.minecraft.class_811;
import net.minecraft.class_918;

public class PotatoCannonItemRenderer extends CustomRenderedItemModelRenderer {

	protected static final PartialModel COG = new PartialModel(Create.asResource("item/potato_cannon/cog"));

	@Override
	protected void render(class_1799 stack, CustomRenderedItemModel model, PartialItemModelRenderer renderer,
		class_811 transformType, class_4587 ms, class_4597 buffer, int light, int overlay) {
		class_310 mc = class_310.method_1551();
		class_918 itemRenderer = mc.method_1480();
		renderer.render(model.getOriginalModel(), light);
		class_746 player = mc.field_1724;
		boolean mainHand = player.method_6047() == stack;
		boolean offHand = player.method_6079() == stack;
		boolean leftHanded = player.method_6068() == class_1306.field_6182;

		float offset = .5f / 16;
		float worldTime = AnimationTickHolder.getRenderTime() / 10;
		float angle = worldTime * -25;
		float speed = CreateClient.POTATO_CANNON_RENDER_HANDLER.getAnimation(mainHand ^ leftHanded,
			AnimationTickHolder.getPartialTicks());

		if (mainHand || offHand)
			angle += 360 * class_3532.method_15363(speed * 5, 0, 1);
		angle %= 360;

		ms.method_22903();
		ms.method_46416(0, offset, 0);
		ms.method_22907(class_7833.field_40718.rotationDegrees(angle));
		ms.method_46416(0, -offset, 0);
		renderer.render(COG.get(), light);
		ms.method_22909();

		if (transformType == class_811.field_4317) {
			PotatoCannonItem.getAmmoforPreview(stack)
				.ifPresent(ammo -> {
					class_4587 localMs = new class_4587();
					localMs.method_46416(-1 / 4f, -1 / 4f, 1);
					localMs.method_22905(.5f, .5f, .5f);
					TransformStack.cast(localMs)
						.rotateY(-34);
					itemRenderer.method_23178(ammo, class_811.field_4317, light, class_4608.field_21444, localMs,
						buffer, mc.field_1687, 0);
				});
		}

	}

}
