package com.simibubi.create.content.equipment.potatoCannon;

import com.simibubi.create.CreateClient;
import com.simibubi.create.content.equipment.zapper.ShootGadgetPacket;
import com.simibubi.create.content.equipment.zapper.ShootableGadgetRenderHandler;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_243;
import net.minecraft.class_2540;

public class PotatoCannonPacket extends ShootGadgetPacket {

	private float pitch;
	private class_243 motion;
	private class_1799 item;

	public PotatoCannonPacket(class_243 location, class_243 motion, class_1799 item, class_1268 hand, float pitch, boolean self) {
		super(location, hand, self);
		this.motion = motion;
		this.item = item;
		this.pitch = pitch;
	}

	public PotatoCannonPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void readAdditional(class_2540 buffer) {
		pitch = buffer.readFloat();
		motion = new class_243(buffer.readFloat(), buffer.readFloat(), buffer.readFloat());
		item = buffer.method_10819();
	}

	@Override
	protected void writeAdditional(class_2540 buffer) {
		buffer.writeFloat(pitch);
		buffer.writeFloat((float) motion.field_1352);
		buffer.writeFloat((float) motion.field_1351);
		buffer.writeFloat((float) motion.field_1350);
		buffer.method_10793(item);
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected void handleAdditional() {
		CreateClient.POTATO_CANNON_RENDER_HANDLER.beforeShoot(pitch, location, motion, item);
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected ShootableGadgetRenderHandler getHandler() {
		return CreateClient.POTATO_CANNON_RENDER_HANDLER;
	}

}
