package com.simibubi.create.content.equipment.sandPaper;

import java.util.List;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_1799;
import net.minecraft.class_1860;
import net.minecraft.class_1937;
import net.minecraft.class_243;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.equipment.sandPaper.SandPaperPolishingRecipe.SandPaperInv;
import com.simibubi.create.content.processing.recipe.ProcessingRecipe;
import com.simibubi.create.content.processing.recipe.ProcessingRecipeBuilder.ProcessingRecipeParams;

import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandlerContainer;

@ParametersAreNonnullByDefault
public class SandPaperPolishingRecipe extends ProcessingRecipe<SandPaperInv> {

	public SandPaperPolishingRecipe(ProcessingRecipeParams params) {
		super(AllRecipeTypes.SANDPAPER_POLISHING, params);
	}

	@Override
	public boolean matches(SandPaperInv inv, class_1937 worldIn) {
		return ingredients.get(0)
			.method_8093(inv.method_5438(0));
	}

	@Override
	protected int getMaxInputCount() {
		return 1;
	}

	@Override
	protected int getMaxOutputCount() {
		return 1;
	}

	public static boolean canPolish(class_1937 world, class_1799 stack) {
		return !getMatchingRecipes(world, stack).isEmpty();
	}

	public static class_1799 applyPolish(class_1937 world, class_243 position, class_1799 stack, class_1799 sandPaperStack) {
		List<class_1860<SandPaperInv>> matchingRecipes = getMatchingRecipes(world, stack);
		if (!matchingRecipes.isEmpty())
			return matchingRecipes.get(0)
				.method_8116(new SandPaperInv(stack), world.method_30349())
				.method_7972();
		return stack;
	}

	public static List<class_1860<SandPaperInv>> getMatchingRecipes(class_1937 world, class_1799 stack) {
		return world.method_8433()
			.method_17877(AllRecipeTypes.SANDPAPER_POLISHING.getType(), new SandPaperInv(stack), world);
	}

	public static class SandPaperInv extends ItemStackHandlerContainer {

		public SandPaperInv(class_1799 stack) {
			super(1);
			setStackInSlot(0, stack);
		}

	}

}
