package com.simibubi.create.content.equipment.symmetryWand;

import com.simibubi.create.content.equipment.symmetryWand.mirror.SymmetryMirror;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class ConfigureSymmetryWandPacket extends SimplePacketBase {

	protected class_1268 hand;
	protected SymmetryMirror mirror;

	public ConfigureSymmetryWandPacket(class_1268 hand, SymmetryMirror mirror) {
		this.hand = hand;
		this.mirror = mirror;
	}

	public ConfigureSymmetryWandPacket(class_2540 buffer) {
		hand = buffer.method_10818(class_1268.class);
		mirror = SymmetryMirror.fromNBT(buffer.method_10798());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10817(hand);
		buffer.method_10794(mirror.writeToNbt());
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null) {
				return;
			}
			class_1799 stack = player.method_5998(hand);
			if (stack.method_7909() instanceof SymmetryWandItem) {
				SymmetryWandItem.configureSettings(stack, mirror);
			}
		});
		return true;
	}

}
