package com.simibubi.create.content.equipment.toolbox;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import io.github.fabricators_of_create.porting_lib.util.TagUtil;
import net.minecraft.class_1767;
import net.minecraft.class_1799;
import net.minecraft.class_1852;
import net.minecraft.class_1865;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2960;
import net.minecraft.class_5455;
import net.minecraft.class_7710;
import net.minecraft.class_8566;

public class ToolboxDyeingRecipe extends class_1852 {

	public ToolboxDyeingRecipe(class_2960 rl, class_7710 category) {
		super(rl, category);
	}

	@Override
	public boolean matches(class_8566 inventory, class_1937 world) {
		int toolboxes = 0;
		int dyes = 0;

		for (int i = 0; i < inventory.method_5439(); ++i) {
			class_1799 stack = inventory.method_5438(i);
			if (!stack.method_7960()) {
				if (class_2248.method_9503(stack.method_7909()) instanceof ToolboxBlock) {
					++toolboxes;
				} else {
					if (!stack.method_31573(Tags.Items.DYES))
						return false;
					++dyes;
				}

				if (dyes > 1 || toolboxes > 1) {
					return false;
				}
			}
		}

		return toolboxes == 1 && dyes == 1;
	}

	@Override
	public class_1799 assemble(class_8566 inventory, class_5455 pRegistryAccess) {
		class_1799 toolbox = class_1799.field_8037;
		class_1767 color = class_1767.field_7957;

		for (int i = 0; i < inventory.method_5439(); ++i) {
			class_1799 stack = inventory.method_5438(i);
			if (!stack.method_7960()) {
				if (class_2248.method_9503(stack.method_7909()) instanceof ToolboxBlock) {
					toolbox = stack;
				} else {
					class_1767 color1 = TagUtil.getColorFromStack(stack);
					if (color1 != null) {
						color = color1;
					}
				}
			}
		}

		class_1799 dyedToolbox = AllBlocks.TOOLBOXES.get(color)
			.asStack();
		if (toolbox.method_7985()) {
			dyedToolbox.method_7980(toolbox.method_7969()
				.method_10553());
		}

		return dyedToolbox;
	}

	@Override
	public boolean method_8113(int width, int height) {
		return width * height >= 2;
	}

	@Override
	public class_1865<?> method_8119() {
		return AllRecipeTypes.TOOLBOX_DYEING.getSerializer();
	}

}
