package com.simibubi.create.content.equipment.zapper;

import java.util.Objects;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_2778;
import net.minecraft.class_3959;
import net.minecraft.class_3959.class_242;
import net.minecraft.class_3959.class_3960;
import net.minecraft.class_3965;
import net.minecraft.class_7924;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.AllTags.AllBlockTags;
import com.simibubi.create.foundation.utility.BlockHelper;

public class ZapperInteractionHandler {

	public static class_1269 leftClickingBlocksWithTheZapperSelectsTheBlock(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		if (world.field_9236)
			return class_1269.field_5811;
		class_1799 heldItem = player
			.method_6047();
		if (heldItem.method_7909() instanceof ZapperItem && trySelect(heldItem, player)) {
//			event.setCancellationResult(InteractionResult.FAIL);
//			event.setCanceled(true);
			return class_1269.field_5814;
		}
		return class_1269.field_5811;
	}

	public static boolean trySelect(class_1799 stack, class_1657 player) {
		if (player.method_5715())
			return false;

		class_243 start = player.method_19538()
			.method_1031(0, player.method_5751(), 0);
		class_243 range = player.method_5720()
			.method_1021(getRange(stack));
		class_3965 raytrace = player.method_37908()
			.method_17742(new class_3959(start, start.method_1019(range), class_3960.field_17559, class_242.field_1348, player));
		class_2338 pos = raytrace.method_17777();
		if (pos == null)
			return false;

		player.method_37908().method_8517(player.method_5628(), pos, -1);
		class_2680 newState = player.method_37908().method_8320(pos);

		if (BlockHelper.getRequiredItem(newState)
			.method_7960())
			return false;
		if (newState.method_31709() && !AllBlockTags.SAFE_NBT.matches(newState))
			return false;
		if (newState.method_28498(class_2741.field_12533))
			return false;
		if (newState.method_28498(class_2741.field_12493))
			return false;
		if (newState.method_28498(class_2741.field_16561))
			return false;
		if (newState.method_28498(class_2741.field_12483))
			return false;
		if (newState.method_28498(class_2741.field_12503))
			newState = newState.method_11657(class_2741.field_12503, class_2778.field_12710);
		if (newState.method_28498(class_2741.field_12514))
			newState = newState.method_11657(class_2741.field_12514, true);
		if (newState.method_28498(class_2741.field_12508))
			newState = newState.method_11657(class_2741.field_12508, false);

		class_2487 data = null;
		class_2586 blockEntity = player.method_37908().method_8321(pos);
		if (blockEntity != null) {
			data = blockEntity.method_38242();
			data.method_10551("x");
			data.method_10551("y");
			data.method_10551("z");
			data.method_10551("id");
		}
		class_2487 tag = stack.method_7948();
		if (tag.method_10545("BlockUsed") && class_2512.method_10681(player.method_37908().method_45448(class_7924.field_41254), stack.method_7969()
			.method_10562("BlockUsed")) == newState && Objects.equals(data, tag.method_10580("BlockData"))) {
			return false;
		}

		tag.method_10566("BlockUsed", class_2512.method_10686(newState));
		if (data == null)
			tag.method_10551("BlockData");
		else
			tag.method_10566("BlockData", data);

		AllSoundEvents.CONFIRM.playOnServer(player.method_37908(), player.method_24515());
		return true;
	}

	public static int getRange(class_1799 stack) {
		if (stack.method_7909() instanceof ZapperItem)
			return ((ZapperItem) stack.method_7909()).getZappingRange(stack);
		return 0;
	}
}
