package com.simibubi.create.content.equipment.zapper;

import java.util.LinkedList;
import java.util.List;
import java.util.stream.Collectors;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_3499.class_3501;

public class ZapperLog {

	private class_1937 activeWorld;
	private List<List<class_3501>> log = new LinkedList<>();
//	private int redoIndex;

	/*
	 * Undo and redo operations applied by tools what information is necessary?
	 *
	 * For survival mode: does undo have the required blocks
	 *
	 * For creative mode: what data did removed TEs have
	 *
	 * When undo: remove added blocks (added -> air) replace replaced blocks (added
	 * -> before) add removed blocks (air -> before)
	 *
	 */

	public void record(class_1937 world, List<class_2338> positions) {
//		if (maxLogLength() == 0)
//			return;
		if (world != activeWorld)
			log.clear();
		activeWorld = world;

		List<class_3501> blocks = positions.stream().map(pos -> {
			class_2586 blockEntity = world.method_8321(pos);
			return new class_3501(pos, world.method_8320(pos), blockEntity == null ? null : blockEntity.method_38242());
		}).collect(Collectors.toList());

		log.add(0, blocks);
//		redoIndex = 0;

//		if (maxLogLength() < log.size())
//			log.remove(log.size() - 1);
	}

//	protected Integer maxLogLength() {
//		return AllConfigs.SERVER.curiosities.zapperUndoLogLength.get();
//	}

	public void undo() {

	}

	public void redo() {

	}

}
