package com.simibubi.create.content.equipment.zapper.terrainzapper;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_243;

public class CuboidBrush extends ShapedBrush {

	public static final int MAX_SIZE = 32;
	private List<class_2338> positions;

	public CuboidBrush() {
		super(3);
		positions = new ArrayList<>();
	}

	@Override
	public void set(int param0, int param1, int param2) {
		boolean updateShape = this.param0 != param0 || this.param1 != param1 || this.param2 != param2;
		super.set(param0, param1, param2);
		if (updateShape) {
			class_2338 zero = class_2338.field_10980;
			positions = class_2338
				.method_20437(zero.method_10069((param0 - 1) / -2, (param1 - 1) / -2, (param2 - 1) / -2),
					zero.method_10069((param0) / 2, (param1) / 2, (param2) / 2))
				.map(class_2338::new)
				.collect(Collectors.toList());
		}
	}

	@Override
	int getMin(int paramIndex) {
		return 1;
	}

	@Override
	int getMax(int paramIndex) {
		return MAX_SIZE;
	}

	@Override
	public class_2338 getOffset(class_243 ray, class_2350 face, PlacementOptions option) {
		if (option == PlacementOptions.Merged)
			return class_2338.field_10980;

		int offset =
			option == PlacementOptions.Attached ? face.method_10171() == class_2352.field_11060 ? 2 : 1 : 0;
		int x = (param0 + (param0 == 0 ? 0 : offset)) / 2;
		int y = (param1 + (param1 == 0 ? 0 : offset)) / 2;
		int z = (param2 + (param2 == 0 ? 0 : offset)) / 2;

		return class_2338.field_10980.method_10079(face, face.method_10166()
			.method_10173(x, y, z) * (option == PlacementOptions.Attached ? 1 : -1));
	}

	@Override
	List<class_2338> getIncludedPositions() {
		return positions;
	}

}
