package com.simibubi.create.content.equipment.zapper.terrainzapper;

import java.util.Collection;
import java.util.List;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_2350;

public abstract class ShapedBrush extends Brush {

	public ShapedBrush(int amtParams) {
		super(amtParams);
	}

	@Override
	public Collection<class_2338> addToGlobalPositions(class_1936 world, class_2338 targetPos, class_2350 targetFace,
		Collection<class_2338> affectedPositions, TerrainTools usedTool) {
		List<class_2338> includedPositions = getIncludedPositions();
		if (includedPositions == null)
			return affectedPositions;
		for (class_2338 blockPos : includedPositions)
			affectedPositions.add(targetPos.method_10081(blockPos));
		return affectedPositions;
	}

	abstract List<class_2338> getIncludedPositions();

}
