package com.simibubi.create.content.fluids.tank;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.api.connectivity.ConnectivityHandler;
import com.simibubi.create.foundation.block.connected.CTSpriteShiftEntry;
import com.simibubi.create.foundation.block.connected.HorizontalCTBehaviour;
import net.minecraft.class_1058;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;

public class FluidTankCTBehaviour extends HorizontalCTBehaviour {

	private CTSpriteShiftEntry innerShift;

	public FluidTankCTBehaviour(CTSpriteShiftEntry layerShift, CTSpriteShiftEntry topShift, CTSpriteShiftEntry innerShift) {
		super(layerShift, topShift);
		this.innerShift = innerShift;
	}

	@Override
	public CTSpriteShiftEntry getShift(class_2680 state, class_2350 direction, @Nullable class_1058 sprite) {
		if (sprite != null && direction.method_10166() == class_2351.field_11052 && innerShift.getOriginal() == sprite)
			return innerShift;
		return super.getShift(state, direction, sprite);
	}

	public boolean buildContextForOccludedDirections() {
		return true;
	}

	@Override
	public boolean connectsTo(class_2680 state, class_2680 other, class_1920 reader, class_2338 pos, class_2338 otherPos,
		class_2350 face) {
		return state.method_26204() == other.method_26204() && ConnectivityHandler.isConnected(reader, pos, otherPos);
	}
}
