package com.simibubi.create.content.kinetics.base;

import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.MaterialManager;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import net.minecraft.class_2350;
import net.minecraft.class_2741;

public class HalfShaftInstance<T extends KineticBlockEntity> extends SingleRotatingInstance<T> {
    public HalfShaftInstance(MaterialManager materialManager, T blockEntity) {
        super(materialManager, blockEntity);
    }

    @Override
    protected Instancer<RotatingData> getModel() {
		class_2350 dir = getShaftDirection();
		return getRotatingMaterial().getModel(AllPartialModels.SHAFT_HALF, blockState, dir);
	}

    protected class_2350 getShaftDirection() {
        return blockState.method_11654(class_2741.field_12525);
    }
}
