package com.simibubi.create.content.kinetics.crank;

import static net.minecraft.class_2741.field_12525;

import com.jozufozu.flywheel.backend.Backend;
import com.simibubi.create.content.kinetics.base.KineticBlockEntityRenderer;
import net.minecraft.class_1921;
import net.minecraft.class_2350;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;

public class HandCrankRenderer extends KineticBlockEntityRenderer<HandCrankBlockEntity> {

	public HandCrankRenderer(class_5614.class_5615 context) {
		super(context);
	}

	@Override
	protected void renderSafe(HandCrankBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		if (be.shouldRenderShaft())
			super.renderSafe(be, partialTicks, ms, buffer, light, overlay);

		if (Backend.canUseInstancing(be.method_10997()))
			return;

		class_2350 facing = be.method_11010()
			.method_11654(field_12525);
		kineticRotationTransform(be.getRenderedHandle(), be, facing.method_10166(), be.getIndependentAngle(partialTicks),
			light).renderInto(ms, buffer.getBuffer(class_1921.method_23577()));
	}

}
