package com.simibubi.create.content.kinetics.fan;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_10;
import net.minecraft.class_1269;
import net.minecraft.class_1750;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_4538;
import net.minecraft.class_6328;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.WrenchableDirectionalBlock;

@class_6328
@ParametersAreNonnullByDefault
public class NozzleBlock extends WrenchableDirectionalBlock implements IBE<NozzleBlockEntity> {

	public NozzleBlock(class_2251 p_i48415_1_) {
		super(p_i48415_1_);
	}
	
	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		return class_1269.field_5814;
	}
	
	@Override
	public class_2680 method_9605(class_1750 context) {
		return method_9564().method_11657(field_10927, context.method_8038());
	}
	
	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.NOZZLE.get(state.method_11654(field_10927));
	}
	
	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
			boolean isMoving) {
		if (worldIn.field_9236)
			return;

		if (fromPos.equals(pos.method_10093(state.method_11654(field_10927).method_10153())))
			if (!method_9558(state, worldIn, pos)) {
				worldIn.method_22352(pos, true);
				return;
			}
	}

	@Override
	public boolean method_9558(class_2680 state, class_4538 worldIn, class_2338 pos) {
		class_2350 towardsFan = state.method_11654(field_10927).method_10153();
		class_2586 be = worldIn.method_8321(pos.method_10093(towardsFan));
		return be instanceof IAirCurrentSource
				&& ((IAirCurrentSource) be).getAirflowOriginSide() == towardsFan.method_10153();
	}
	
	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public Class<NozzleBlockEntity> getBlockEntityClass() {
		return NozzleBlockEntity.class;
	}

	@Override
	public class_2591<? extends NozzleBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.NOZZLE.get();
	}

}
