package com.simibubi.create.content.kinetics.gearbox;

import java.util.Map;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.base.IRotate;
import com.simibubi.create.foundation.utility.Iterate;

public class VerticalGearboxItem extends class_1747 {

	public VerticalGearboxItem(class_1793 builder) {
		super(AllBlocks.GEARBOX.get(), builder);
	}
	
	@Override
	public String method_7876() {
		return "item.create.vertical_gearbox";
	}

	@Override
	public void method_7713(Map<class_2248, class_1792> p_195946_1_, class_1792 p_195946_2_) {
	}

	@Override
	protected boolean method_7710(class_2338 pos, class_1937 world, class_1657 player, class_1799 stack, class_2680 state) {
		class_2351 prefferedAxis = null;
		for (class_2350 side : Iterate.horizontalDirections) {
			class_2680 blockState = world.method_8320(pos.method_10093(side));
			if (blockState.method_26204() instanceof IRotate) {
				if (((IRotate) blockState.method_26204()).hasShaftTowards(world, pos.method_10093(side), blockState,
						side.method_10153()))
					if (prefferedAxis != null && prefferedAxis != side.method_10166()) {
						prefferedAxis = null;
						break;
					} else {
						prefferedAxis = side.method_10166();
					}
			}
		}

		class_2351 axis = prefferedAxis == null ? player.method_5735()
				.method_10170()
				.method_10166() : prefferedAxis == class_2351.field_11048 ? class_2351.field_11051 : class_2351.field_11048;
		world.method_8501(pos, state.method_11657(class_2741.field_12496, axis));
		return super.method_7710(pos, world, player, stack, state);
	}

}
