package com.simibubi.create.content.kinetics.motor;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import net.minecraft.class_10;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_4538;

public class CreativeMotorBlock extends DirectionalKineticBlock implements IBE<CreativeMotorBlockEntity> {

	public CreativeMotorBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.MOTOR_BLOCK.get(state.method_11654(FACING));
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2350 preferred = getPreferredFacing(context);
		if ((context.method_8036() != null && context.method_8036()
			.method_5715()) || preferred == null)
			return super.method_9605(context);
		return method_9564().method_11657(FACING, preferred);
	}

	// IRotate:

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face == state.method_11654(FACING);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public boolean hideStressImpact() {
		return true;
	}
	
	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public Class<CreativeMotorBlockEntity> getBlockEntityClass() {
		return CreativeMotorBlockEntity.class;
	}

	@Override
	public class_2591<? extends CreativeMotorBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.MOTOR.get();
	}
	
}
