package com.simibubi.create.content.kinetics.press;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.HorizontalKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import net.minecraft.class_10;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_3727;
import net.minecraft.class_4538;

public class MechanicalPressBlock extends HorizontalKineticBlock implements IBE<MechanicalPressBlockEntity> {

	public MechanicalPressBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		if (context instanceof class_3727
			&& ((class_3727) context).method_32480() instanceof class_1657)
			return AllShapes.CASING_14PX.get(class_2350.field_11033);

		return AllShapes.MECHANICAL_PROCESSOR_SHAPE;
	}

	@Override
	public boolean method_9558(class_2680 state, class_4538 worldIn, class_2338 pos) {
		return !AllBlocks.BASIN.has(worldIn.method_8320(pos.method_10074()));
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2350 prefferedSide = getPreferredHorizontalFacing(context);
		if (prefferedSide != null)
			return method_9564().method_11657(HORIZONTAL_FACING, prefferedSide);
		return super.method_9605(context);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(HORIZONTAL_FACING)
			.method_10166();
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face.method_10166() == state.method_11654(HORIZONTAL_FACING)
			.method_10166();
	}

	@Override
	public Class<MechanicalPressBlockEntity> getBlockEntityClass() {
		return MechanicalPressBlockEntity.class;
	}

	@Override
	public class_2591<? extends MechanicalPressBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.MECHANICAL_PRESS.get();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
