package com.simibubi.create.content.kinetics.saw;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_4587;

public class SawFilterSlot extends ValueBoxTransform {

	@Override
	public class_243 getLocalOffset(class_2680 state) {
		if (state.method_11654(SawBlock.FACING) != class_2350.field_11036)
			return null;
		int offset = state.method_11654(SawBlock.FLIPPED) ? -3 : 3;
		class_243 x = VecHelper.voxelSpace(8, 12.5f, 8 + offset);
		class_243 z = VecHelper.voxelSpace(8 + offset, 12.5f, 8);
		return state.method_11654(SawBlock.AXIS_ALONG_FIRST_COORDINATE) ? z : x;
	}

	@Override
	public void rotate(class_2680 state, class_4587 ms) {
		int yRot = (state.method_11654(SawBlock.AXIS_ALONG_FIRST_COORDINATE) ? 90 : 0)
			+ (state.method_11654(SawBlock.FLIPPED) ? 0 : 180);
		TransformStack.cast(ms)
			.rotateY(yRot)
			.rotateX(90);
	}

}
