package com.simibubi.create.content.kinetics.saw;

import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.MaterialManager;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.SingleRotatingInstance;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import net.minecraft.class_2350;
import net.minecraft.class_2470;
import net.minecraft.class_2680;
import net.minecraft.class_2741;

public class SawInstance extends SingleRotatingInstance<SawBlockEntity> {

	public SawInstance(MaterialManager materialManager, SawBlockEntity blockEntity) {
		super(materialManager, blockEntity);
	}

	@Override
	protected Instancer<RotatingData> getModel() {
		if (blockState.method_11654(class_2741.field_12525)
			.method_10166()
			.method_10179()) {
			class_2680 referenceState = blockState.method_26186(class_2470.field_11464);
			class_2350 facing = referenceState.method_11654(class_2741.field_12525);
			return getRotatingMaterial().getModel(AllPartialModels.SHAFT_HALF, referenceState, facing);
		} else {
			return getRotatingMaterial().getModel(shaft());
		}
	}
}
