package com.simibubi.create.content.kinetics.simpleRelays;

import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.base.RotatedPillarKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import net.minecraft.class_10;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_3610;
import net.minecraft.class_4538;

public abstract class AbstractShaftBlock extends RotatedPillarKineticBlock
	implements IBE<KineticBlockEntity>, ProperWaterloggedBlock {

	public AbstractShaftBlock(class_2251 properties) {
		super(properties);
		method_9590(super.method_9564().method_11657(class_2741.field_12508, false));
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public Class<KineticBlockEntity> getBlockEntityClass() {
		return KineticBlockEntity.class;
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face.method_10166() == state.method_11654(AXIS);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(AXIS);
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return fluidState(state);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(class_2741.field_12508));
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState, class_1936 world,
		class_2338 pos, class_2338 neighbourPos) {
		updateWater(world, state, pos);
		return state;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		return withWater(super.method_9605(context), context);
	}

}
