package com.simibubi.create.content.kinetics.simpleRelays;

import com.simibubi.create.content.kinetics.base.IRotate;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2248;
import net.minecraft.class_2680;

public interface ICogWheel extends IRotate {

	static boolean isSmallCog(class_2680 state) {
		return isSmallCog(state.method_26204());
	}

	static boolean isLargeCog(class_2680 state) {
		return isLargeCog(state.method_26204());
	}

	static boolean isSmallCog(class_2248 block) {
		return block instanceof ICogWheel && ((ICogWheel) block).isSmallCog();
	}

	static boolean isLargeCog(class_2248 block) {
		return block instanceof ICogWheel && ((ICogWheel) block).isLargeCog();
	}

	static boolean isDedicatedCogWheel(class_2248 block) {
		return block instanceof ICogWheel && ((ICogWheel) block).isDedicatedCogWheel();
	}

	static boolean isDedicatedCogItem(class_1799 test) {
		class_1792 item = test.method_7909();
		if (!(item instanceof class_1747))
			return false;
		return isDedicatedCogWheel(((class_1747) item).method_7711());
	}

	static boolean isSmallCogItem(class_1799 test) {
		class_1792 item = test.method_7909();
		if (!(item instanceof class_1747))
			return false;
		return isSmallCog(((class_1747) item).method_7711());
	}

	static boolean isLargeCogItem(class_1799 test) {
		class_1792 item = test.method_7909();
		if (!(item instanceof class_1747))
			return false;
		return isLargeCog(((class_1747) item).method_7711());
	}

	default boolean isLargeCog() {
		return false;
	}

	default boolean isSmallCog() {
		return !isLargeCog();
	}

	default boolean isDedicatedCogWheel() {
		return false;
	}
}
