package com.simibubi.create.content.logistics.depot;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_3222;


public class EjectorElytraPacket extends SimplePacketBase {

	private class_2338 pos;

	public EjectorElytraPacket(class_2338 pos) {
		this.pos = pos;
	}

	public EjectorElytraPacket(class_2540 buffer) {
		pos = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(pos);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
					class_3222 player = context.getSender();
					if (player == null)
						return;
					class_1937 world = player.method_37908();
					if (world == null || !world.method_8477(pos))
						return;
					class_2586 blockEntity = world.method_8321(pos);
					if (blockEntity instanceof EjectorBlockEntity)
						((EjectorBlockEntity) blockEntity).deployElytra(player);
				});
		return true;
	}

}
