package com.simibubi.create.content.logistics.filter;

import com.simibubi.create.foundation.gui.menu.GhostItemMenu;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1713;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3917;

public abstract class AbstractFilterMenu extends GhostItemMenu<class_1799> {

	protected AbstractFilterMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	protected AbstractFilterMenu(class_3917<?> type, int id, class_1661 inv, class_1799 contentHolder) {
		super(type, id, inv, contentHolder);
	}

	@Override
	public void method_7593(int slotId, int dragType, class_1713 clickTypeIn, class_1657 player) {
		if (slotId == playerInventory.field_7545 && clickTypeIn != class_1713.field_7795)
			return;
		super.method_7593(slotId, dragType, clickTypeIn, player);
	}

	@Override
	protected boolean allowRepeats() {
		return false;
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected class_1799 createOnClient(class_2540 extraData) {
		return extraData.method_10819();
	}

	protected abstract int getPlayerInventoryXOffset();

	protected abstract int getPlayerInventoryYOffset();

	protected abstract void addFilterSlots();

	@Override
	protected void addSlots() {
		addPlayerSlots(getPlayerInventoryXOffset(), getPlayerInventoryYOffset());
		addFilterSlots();
	}

	@Override
	protected void saveData(class_1799 contentHolder) {
		contentHolder.method_7948()
				.method_10566("Items", ghostInventory.serializeNBT());
	}

	@Override
	public boolean method_7597(class_1657 player) {
		return playerInventory.method_7391() == contentHolder;
	}

}
