package com.simibubi.create.content.logistics.funnel;

import io.github.fabricators_of_create.porting_lib.item.BlockUseBypassingItem;
import net.minecraft.class_1268;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import org.apache.logging.log4j.core.Filter.Result;

public class FunnelItem extends class_1747 implements BlockUseBypassingItem {

	public FunnelItem(class_2248 p_i48527_1_, class_1793 p_i48527_2_) {
		super(p_i48527_1_, p_i48527_2_);
	}

	// fabric: handled by BlockUseBypassingItem
//	public static void funnelItemAlwaysPlacesWhenUsed(PlayerInteractEvent.RightClickBlock event) {
//		if (event.getItemStack()
//				.getItem() instanceof FunnelItem)
//			event.setUseBlock(Result.DENY);
//	}

	@Override
	protected class_2680 method_7707(class_1750 ctx) {
		class_1937 world = ctx.method_8045();
		class_2338 pos = ctx.method_8037();
		class_2680 state = super.method_7707(ctx);
		if (state == null)
			return state;
		if (!(state.method_26204() instanceof FunnelBlock))
			return state;
		if (state.method_11654(FunnelBlock.FACING)
			.method_10166()
			.method_10178())
			return state;

		class_2350 direction = state.method_11654(FunnelBlock.FACING);
		FunnelBlock block = (FunnelBlock) method_7711();
		class_2248 beltFunnelBlock = block.getEquivalentBeltFunnel(world, pos, state)
			.method_26204();
		class_2680 equivalentBeltFunnel = beltFunnelBlock.method_9605(ctx)
			.method_11657(BeltFunnelBlock.HORIZONTAL_FACING, direction);
		if (BeltFunnelBlock.isOnValidBelt(equivalentBeltFunnel, world, pos))
			return equivalentBeltFunnel;

		return state;
	}

	@Override
	public boolean shouldBypass(class_2680 state, class_2338 pos, class_1937 level, class_1657 player, class_1268 hand) {
		return true;
	}
}
