package com.simibubi.create.content.logistics.tunnel;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.belt.BeltBlockEntity;
import com.simibubi.create.content.kinetics.belt.BeltBlockEntity.CasingType;
import com.simibubi.create.content.kinetics.belt.BeltHelper;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3726;

public class BeltTunnelItem extends class_1747 {

	public BeltTunnelItem(class_2248 p_i48527_1_, class_1793 p_i48527_2_) {
		super(p_i48527_1_, p_i48527_2_);
	}

	@Override
	protected boolean method_7709(class_1750 ctx, class_2680 state) {
		class_1657 playerentity = ctx.method_8036();
		class_3726 iselectioncontext =
			playerentity == null ? class_3726.method_16194() : class_3726.method_16195(playerentity);
		class_1937 world = ctx.method_8045();
		class_2338 pos = ctx.method_8037();
		return (!this.method_20360() || AllBlocks.ANDESITE_TUNNEL.get()
			.isValidPositionForPlacement(state, world, pos)) && world.method_8628(state, pos, iselectioncontext);
	}

	@Override
	protected boolean method_7710(class_2338 pos, class_1937 world, class_1657 p_195943_3_, class_1799 p_195943_4_,
		class_2680 state) {
		boolean flag = super.method_7710(pos, world, p_195943_3_, p_195943_4_, state);
		if (!world.field_9236) {
			BeltBlockEntity belt = BeltHelper.getSegmentBE(world, pos.method_10074());
			if (belt != null && belt.casing == CasingType.NONE)
				belt.setCasingType(AllBlocks.ANDESITE_TUNNEL.has(state) ? CasingType.ANDESITE : CasingType.BRASS);
		}
		return flag;
	}

}
