package com.simibubi.create.content.logistics.tunnel;

import java.util.List;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3965;
import net.minecraft.class_4970;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.foundation.block.IBE;

public class BrassTunnelBlock extends BeltTunnelBlock {

	public BrassTunnelBlock(class_4970.class_2251 properties) {
		super(properties);
	}

	@Override
	public class_1269 method_9534(class_2680 p_225533_1_, class_1937 world, class_2338 pos, class_1657 player,
		class_1268 p_225533_5_, class_3965 p_225533_6_) {
		return onBlockEntityUse(world, pos, be -> {
			if (!(be instanceof BrassTunnelBlockEntity))
				return class_1269.field_5811;
			BrassTunnelBlockEntity bte = (BrassTunnelBlockEntity) be;
			List<class_1799> stacksOfGroup = bte.grabAllStacksOfGroup(world.field_9236);
			if (stacksOfGroup.isEmpty())
				return class_1269.field_5811;
			if (world.field_9236)
				return class_1269.field_5812;
			for (class_1799 itemStack : stacksOfGroup) 
				player.method_31548().method_7398(itemStack.method_7972());
			world.method_8396(null, pos, class_3417.field_15197, class_3419.field_15248, .2f,
				1f + world.field_9229.method_43057());
			return class_1269.field_5812;
		});
	}

	@Override
	public class_2591<? extends BeltTunnelBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.BRASS_TUNNEL.get();
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 facing, class_2680 facingState, class_1936 worldIn,
		class_2338 currentPos, class_2338 facingPos) {
		return super.method_9559(state, facing, facingState, worldIn, currentPos, facingPos);
	}

	@Override
	public void method_9536(class_2680 state, class_1937 level, class_2338 pos, class_2680 newState, boolean isMoving) {
		IBE.onRemove(state, level, pos, newState);
	}

}
