package com.simibubi.create.content.processing;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.belt.BeltBlock;
import com.simibubi.create.content.kinetics.belt.BeltSlope;
import net.minecraft.class_1269;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3965;

public class AssemblyOperatorBlockItem extends class_1747 {

	public AssemblyOperatorBlockItem(class_2248 block, class_1793 builder) {
		super(block, builder);
	}

	@Override
	public class_1269 method_7712(class_1750 context) {
		class_2338 placedOnPos = context.method_8037()
			.method_10093(context.method_8038()
				.method_10153());
		class_2680 placedOnState = context.method_8045()
			.method_8320(placedOnPos);
		if (operatesOn(placedOnState) && context.method_8038() == class_2350.field_11036) {
			if (context.method_8045()
				.method_8320(placedOnPos.method_10086(2))
				.method_45474())
				context = adjustContext(context, placedOnPos);
			else
				return class_1269.field_5814;
		}

		return super.method_7712(context);
	}

	protected class_1750 adjustContext(class_1750 context, class_2338 placedOnPos) {
		class_2338 up = placedOnPos.method_10086(2);
		return new AssemblyOperatorUseContext(context.method_8045(), context.method_8036(), context.method_20287(), context.method_8041(), new class_3965(new class_243((double)up.method_10263() + 0.5D + (double) class_2350.field_11036.method_10148() * 0.5D, (double)up.method_10264() + 0.5D + (double) class_2350.field_11036.method_10164() * 0.5D, (double)up.method_10260() + 0.5D + (double) class_2350.field_11036.method_10165() * 0.5D), class_2350.field_11036, up, false));
	}

	protected boolean operatesOn(class_2680 placedOnState) {
		if (AllBlocks.BELT.has(placedOnState))
			return placedOnState.method_11654(BeltBlock.SLOPE) == BeltSlope.HORIZONTAL;
		return AllBlocks.BASIN.has(placedOnState) || AllBlocks.DEPOT.has(placedOnState) || AllBlocks.WEIGHTED_EJECTOR.has(placedOnState);
	}

}
