package com.simibubi.create.content.processing.sequenced;

import java.util.List;
import java.util.Set;

import com.simibubi.create.compat.recipeViewerCommon.SequencedAssemblySubCategoryType;
import com.simibubi.create.foundation.fluid.FluidIngredient;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_2561;

public interface IAssemblyRecipe {

	default boolean supportsAssembly() {
		return true;
	}

	@Environment(EnvType.CLIENT)
	public class_2561 getDescriptionForAssembly();

	public void addRequiredMachines(Set<class_1935> list);

	public void addAssemblyIngredients(List<class_1856> list);

	default void addAssemblyFluidIngredients(List<FluidIngredient> list) {}

	public SequencedAssemblySubCategoryType getJEISubCategory();

}
