package com.simibubi.create.content.redstone;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_4587;

public class FilteredDetectorFilterSlot extends ValueBoxTransform.Sided {

	private boolean hasSlotAtBottom;

	public FilteredDetectorFilterSlot(boolean hasSlotAtBottom) {
		this.hasSlotAtBottom = hasSlotAtBottom;
	}

	@Override
	protected boolean isSideActive(class_2680 state, class_2350 direction) {
		class_2350 targetDirection = DirectedDirectionalBlock.getTargetDirection(state);
		if (direction == targetDirection)
			return false;
		if (targetDirection.method_10153() == direction)
			return true;

		if (targetDirection.method_10166() != class_2351.field_11052)
			return direction == class_2350.field_11036 || direction == class_2350.field_11033 && hasSlotAtBottom;
		if (targetDirection == class_2350.field_11036)
			direction = direction.method_10153();
		if (!hasSlotAtBottom)
			return direction == state.method_11654(DirectedDirectionalBlock.field_11177);

		return direction.method_10166() == state.method_11654(DirectedDirectionalBlock.field_11177)
			.method_10170()
			.method_10166();
	}

	@Override
	public void rotate(class_2680 state, class_4587 ms) {
		super.rotate(state, ms);
		class_2350 facing = state.method_11654(DirectedDirectionalBlock.field_11177);
		if (facing.method_10166() == class_2351.field_11052)
			return;
		if (getSide() != class_2350.field_11036)
			return;
		TransformStack.cast(ms)
			.rotateZ(-AngleHelper.horizontalAngle(facing) + 180);
	}

	@Override
	protected class_243 getSouthLocation() {
		return VecHelper.voxelSpace(8f, 8f, 15.5f);
	}

}
