package com.simibubi.create.content.redstone.diodes;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.block.IBE;
import io.github.fabricators_of_create.porting_lib.block.ConnectableRedstoneBlock;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3965;

public class BrassDiodeBlock extends AbstractDiodeBlock implements IBE<BrassDiodeBlockEntity>, ConnectableRedstoneBlock {

	public static final class_2746 POWERING = class_2746.method_11825("powering");
	public static final class_2746 INVERTED = class_2746.method_11825("inverted");

	public BrassDiodeBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(field_10911, false)
			.method_11657(POWERING, false)
			.method_11657(INVERTED, false));
	}

	@Override
	public class_1269 method_9534(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_1657 player, class_1268 pHand,
		class_3965 pHit) {
		return toggle(pLevel, pPos, pState, player, pHand);
	}

	public class_1269 toggle(class_1937 pLevel, class_2338 pPos, class_2680 pState, class_1657 player,
		class_1268 pHand) {
		if (!player.method_7294())
			return class_1269.field_5811;
		if (player.method_5715())
			return class_1269.field_5811;
		if (AllItems.WRENCH.isIn(player.method_5998(pHand)))
			return class_1269.field_5811;
		if (pLevel.field_9236)
			return class_1269.field_5812;
		pLevel.method_8652(pPos, pState.method_28493(INVERTED), 3);
		float f = !pState.method_11654(INVERTED) ? 0.6F : 0.5F;
		pLevel.method_8396(null, pPos, class_3417.field_14962, class_3419.field_15245, 0.3F, f);
		return class_1269.field_5812;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(field_10911, POWERING, field_11177, INVERTED);
		super.method_9515(builder);
	}

	@Override
	protected int method_9993(class_1922 worldIn, class_2338 pos, class_2680 state) {
		return state.method_11654(POWERING) ^ state.method_11654(INVERTED) ? 15 : 0;
	}

	@Override
	public int method_9524(class_2680 blockState, class_1922 blockAccess, class_2338 pos, class_2350 side) {
		return blockState.method_11654(field_11177) == side ? this.method_9993(blockAccess, pos, blockState) : 0;
	}

	@Override
	protected int method_9992(class_2680 p_196346_1_) {
		return 2;
	}

	@Override
	public boolean canConnectRedstone(class_2680 state, class_1922 world, class_2338 pos, class_2350 side) {
		if (side == null)
			return false;
		return side.method_10166() == state.method_11654(field_11177)
			.method_10166();
	}

	@Override
	public Class<BrassDiodeBlockEntity> getBlockEntityClass() {
		return BrassDiodeBlockEntity.class;
	}

	@Override
	public class_2591<? extends BrassDiodeBlockEntity> getBlockEntityType() {
		return AllBlocks.PULSE_EXTENDER.is(this) ? AllBlockEntityTypes.PULSE_EXTENDER.get()
			: AllBlockEntityTypes.PULSE_REPEATER.get();
	}

}
