package com.simibubi.create.content.redstone.diodes;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_4587;

public class BrassDiodeScrollSlot extends ValueBoxTransform {

	@Override
	public class_243 getLocalOffset(class_2680 state) {
		return VecHelper.voxelSpace(8, 2.6f, 8);
	}

	@Override
	public void rotate(class_2680 state, class_4587 ms) {
		float yRot = AngleHelper.horizontalAngle(state.method_11654(class_2741.field_12481)) + 180;
		TransformStack.cast(ms)
			.rotateY(yRot)
			.rotateX(90);
	}

	@Override
	public int getOverrideColor() {
		return 0x592424;
	}
	
}
