package com.simibubi.create.content.redstone.diodes;

import java.util.Vector;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import com.tterrag.registrate.providers.DataGenContext;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.block.BlockModelProvider;

public class ToggleLatchGenerator extends AbstractDiodeGenerator {

	@Override
	protected <T extends class_2248> Vector<ModelFile> createModels(DataGenContext<class_2248, T> ctx, BlockModelProvider prov) {
		String name = ctx.getName();
		Vector<ModelFile> models = makeVector(4);
		class_2960 off = existing("latch_off");
		class_2960 on = existing("latch_on");

		models.add(prov.getExistingFile(off));
		models.add(prov.withExistingParent(name + "_off_powered", off)
			.texture("top", texture(ctx, "powered")));
		models.add(prov.getExistingFile(on));
		models.add(prov.withExistingParent(name + "_on_powered", on)
			.texture("top", texture(ctx, "powered_powering")));

		return models;
	}

	@Override
	protected int getModelIndex(class_2680 state) {
		return (state.method_11654(ToggleLatchBlock.POWERING) ? 2 : 0) + (state.method_11654(ToggleLatchBlock.field_10911) ? 1 : 0);
	}

}
