package com.simibubi.create.content.redstone.displayLink.source;

import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTargetStats;
import com.simibubi.create.foundation.utility.Components;

import io.github.fabricators_of_create.porting_lib.enchant.EnchantmentBonusBlock;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1890;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2331;
import net.minecraft.class_2338;
import net.minecraft.class_2605;
import net.minecraft.class_2680;
import net.minecraft.class_5250;
import net.minecraft.class_5819;

public class EnchantPowerDisplaySource extends NumericSingleLineDisplaySource {

	protected static final class_5819 random = class_5819.method_43047();
	protected static final class_1799 stack = new class_1799(class_1802.field_8377);

	@Override
	protected class_5250 provideLine(DisplayLinkContext context, DisplayTargetStats stats) {
		if (!(context.getSourceBlockEntity() instanceof class_2605))
			return ZERO.method_27661();

		class_2338 pos = context.getSourcePos();
		class_1937 level = context.level();
		float enchantPower = 0;

		for(class_2338 offset : class_2331.field_36535) {
			if (!class_2331.method_40445(level, pos, offset))
				continue;
			class_2338 bookPos = pos.method_10081(offset);
			class_2680 state = level.method_8320(bookPos);
			enchantPower += state.method_26204() instanceof EnchantmentBonusBlock bonus
					? bonus.getEnchantPowerBonus(state, level, pos)
					: state.method_27852(class_2246.field_10504)
						? 1
						: 0;
		}


		int cost = class_1890.method_8227(random, 2, (int) enchantPower, stack);

		return Components.literal(String.valueOf(cost));
	}

	@Override
	protected String getTranslationKey() {
		return "max_enchant_level";
	}

	@Override
	protected boolean allowsLabeling(DisplayLinkContext context) {
		return true;
	}
}
