package com.simibubi.create.content.redstone.displayLink.target;

import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2519;
import net.minecraft.class_2520;
import net.minecraft.class_2561;
import net.minecraft.class_2586;
import net.minecraft.class_3722;
import net.minecraft.class_5250;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.utility.Lang;

public class LecternDisplayTarget extends DisplayTarget {

	@Override
	public void acceptText(int line, List<class_5250> text, DisplayLinkContext context) {
		class_2586 be = context.getTargetBlockEntity();
		if (!(be instanceof class_3722 lectern))
			return;
		class_1799 book = lectern.method_17520();
		if (book.method_7960())
			return;

		if (book.method_31574(class_1802.field_8674))
			lectern.method_17513(book = signBook(book));
		if (!book.method_31574(class_1802.field_8360))
			return;

		class_2499 tag = book.method_7969()
			.method_10554("pages", class_2520.field_33258);

		boolean changed = false;
		for (int i = 0; i - line < text.size() && i < 50; i++) {
			if (tag.size() <= i)
				tag.add(class_2519.method_23256(i < line ? "" : class_2561.class_2562.method_10867(text.get(i - line))));

			else if (i >= line) {
				if (i - line == 0)
					reserve(i, lectern, context);
				if (i - line > 0 && isReserved(i - line, lectern, context))
					break;

				tag.method_10606(i, class_2519.method_23256(class_2561.class_2562.method_10867(text.get(i - line))));
			}
			changed = true;
		}

		book.method_7969()
			.method_10566("pages", tag);
		lectern.method_17513(book);

		if (changed)
			context.level().method_8413(context.getTargetPos(), lectern.method_11010(), lectern.method_11010(), 2);
	}

	@Override
	public DisplayTargetStats provideStats(DisplayLinkContext context) {
		return new DisplayTargetStats(50, 256, this);
	}

	public class_2561 getLineOptionText(int line) {
		return Lang.translateDirect("display_target.page", line + 1);
	}

	private class_1799 signBook(class_1799 book) {
		class_1799 written = new class_1799(class_1802.field_8360);
		class_2487 compoundtag = book.method_7969();
		if (compoundtag != null)
			written.method_7980(compoundtag.method_10553());

		written.method_7959("author", class_2519.method_23256("Data Gatherer"));
		written.method_7959("filtered_title", class_2519.method_23256("Printed Book"));
		written.method_7959("title", class_2519.method_23256("Printed Book"));

		return written;
	}

}
