package com.simibubi.create.content.redstone.displayLink.target;

import java.util.List;
import net.minecraft.class_2586;
import net.minecraft.class_2625;
import net.minecraft.class_5250;
import net.minecraft.class_8242;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.utility.Iterate;

public class SignDisplayTarget extends DisplayTarget {

	@Override
	public void acceptText(int line, List<class_5250> text, DisplayLinkContext context) {
		class_2586 be = context.getTargetBlockEntity();
		if (!(be instanceof class_2625 sign))
			return;

		boolean changed = false;
		class_8242 signText = new class_8242();
		for (int i = 0; i < text.size() && i + line < 4; i++) {
			if (i == 0)
				reserve(i + line, sign, context);
			if (i > 0 && isReserved(i + line, sign, context))
				break;

			signText.method_49857(i + line, text.get(i));
			changed = true;
		}

		if (changed)
			for (boolean side : Iterate.trueAndFalse)
				sign.method_49840(signText, side);
		context.level()
			.method_8413(context.getTargetPos(), sign.method_11010(), sign.method_11010(), 2);
	}

	@Override
	public DisplayTargetStats provideStats(DisplayLinkContext context) {
		return new DisplayTargetStats(4, 15, this);
	}

}
