package com.simibubi.create.content.redstone.link;

import java.util.Arrays;

import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.RaycastHelper;

import net.fabricmc.fabric.api.entity.FakePlayer;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3965;

public class LinkHandler {

	public static class_1269 onBlockActivated(class_1657 player, class_1937 world, class_1268 hand, class_3965 blockRayTraceResult) {
		class_2338 pos = blockRayTraceResult.method_17777();
		if (player.method_5715() || player.method_7325())
			return class_1269.field_5811;

		LinkBehaviour behaviour = BlockEntityBehaviour.get(world, pos, LinkBehaviour.TYPE);
		if (behaviour == null)
			return class_1269.field_5811;
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1799 heldItem = player.method_5998(hand);
		class_3965 ray = RaycastHelper.rayTraceRange(world, player, 10);
		if (ray == null)
			return class_1269.field_5811;
		if (AllItems.LINKED_CONTROLLER.isIn(heldItem))
			return class_1269.field_5811;
		if (AllItems.WRENCH.isIn(heldItem))
			return class_1269.field_5811;

		boolean fakePlayer = player instanceof FakePlayer;
		boolean fakePlayerChoice = false;

		if (fakePlayer) {
			class_2680 blockState = world.method_8320(pos);
			class_243 localHit = ray.method_17784()
				.method_1020(class_243.method_24954(pos))
				.method_1019(class_243.method_24954(ray.method_17780()
					.method_10163())
					.method_1021(.25f));
			fakePlayerChoice = localHit.method_1025(behaviour.firstSlot.getLocalOffset(blockState)) > localHit
				.method_1025(behaviour.secondSlot.getLocalOffset(blockState));
		}

		for (boolean first : Arrays.asList(false, true)) {
			if (behaviour.testHit(first, ray.method_17784()) || fakePlayer && fakePlayerChoice == first) {
				if (!world.field_9236)
					behaviour.setFrequency(first, heldItem);
				world.method_8396(null, pos, class_3417.field_14667, class_3419.field_15245, .25f, .1f);
				return class_1269.field_5812;
			}
		}
		return class_1269.field_5811;
	}

}
