package com.simibubi.create.content.redstone.link;

import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_2680;

public class RedstoneLinkGenerator extends SpecialBlockStateGen {

	@Override
	protected int getXRotation(class_2680 state) {
		class_2350 facing = state.method_11654(RedstoneLinkBlock.field_10927);
		return facing == class_2350.field_11036 ? 0 : facing == class_2350.field_11033 ? 180 : 270;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		class_2350 facing = state.method_11654(RedstoneLinkBlock.field_10927);
		return facing.method_10166()
			.method_10178() ? 180 : horizontalAngle(facing);
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		String variant = state.method_11654(RedstoneLinkBlock.RECEIVER) ? "receiver" : "transmitter";
		if (state.method_11654(RedstoneLinkBlock.field_10927).method_10166().method_10179())
			variant += "_vertical";
		if (state.method_11654(RedstoneLinkBlock.POWERED))
			variant += "_powered";

		return prov.models().getExistingFile(prov.modLoc("block/redstone_link/" + variant));
	}

}
