package com.simibubi.create.content.redstone.link.controller;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.blockEntity.renderer.SafeBlockEntityRenderer;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModel;
import com.simibubi.create.foundation.item.render.PartialItemModelRenderer;
import com.simibubi.create.foundation.utility.AngleHelper;
import net.minecraft.class_1799;
import net.minecraft.class_2350;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_811;

public class LecternControllerRenderer extends SafeBlockEntityRenderer<LecternControllerBlockEntity> {

	public LecternControllerRenderer(class_5614.class_5615 context) {
	}

	@Override
	protected void renderSafe(LecternControllerBlockEntity be, float partialTicks, class_4587 ms,
  		class_4597 buffer, int light, int overlay) {

		class_1799 stack = AllItems.LINKED_CONTROLLER.asStack();
		class_811 transformType = class_811.field_4315;
		CustomRenderedItemModel mainModel = (CustomRenderedItemModel) class_310.method_1551()
			.method_1480()
			.method_4019(stack, be.method_10997(), null, 0);
		PartialItemModelRenderer renderer = PartialItemModelRenderer.of(stack, transformType, ms, buffer, overlay);
		boolean active = be.hasUser();
		boolean renderDepression = be.isUsedBy(class_310.method_1551().field_1724);

		class_2350 facing = be.method_11010().method_11654(LecternControllerBlock.field_16404);
		TransformStack msr = TransformStack.cast(ms);

		ms.method_22903();
		msr.translate(0.5, 1.45, 0.5);
		msr.rotateY(AngleHelper.horizontalAngle(facing) - 90);
		msr.translate(0.28, 0, 0);
		msr.rotateZ(-22.0);
		LinkedControllerItemRenderer.renderInLectern(stack, mainModel, renderer, transformType, ms, light, active, renderDepression);
		ms.method_22909();
	}

}
