package com.simibubi.create.content.redstone.link.controller;

import com.simibubi.create.AllMenuTypes;
import com.simibubi.create.foundation.gui.menu.GhostItemMenu;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;

import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1713;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3917;

public class LinkedControllerMenu extends GhostItemMenu<class_1799> {

	public LinkedControllerMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	public LinkedControllerMenu(class_3917<?> type, int id, class_1661 inv, class_1799 filterItem) {
		super(type, id, inv, filterItem);
	}

	public static LinkedControllerMenu create(int id, class_1661 inv, class_1799 filterItem) {
		return new LinkedControllerMenu(AllMenuTypes.LINKED_CONTROLLER.get(), id, inv, filterItem);
	}

	@Override
	protected class_1799 createOnClient(class_2540 extraData) {
		return extraData.method_10819();
	}

	@Override
	protected ItemStackHandler createGhostInventory() {
		return LinkedControllerItem.getFrequencyItems(contentHolder);
	}

	@Override
	protected void addSlots() {
		addPlayerSlots(8, 131);

		int x = 12;
		int y = 34;
		int slot = 0;

		for (int column = 0; column < 6; column++) {
			for (int row = 0; row < 2; ++row)
				method_7621(new SlotItemHandler(ghostInventory, slot++, x, y + row * 18));
			x += 24;
			if (column == 3)
				x += 11;
		}
	}

	@Override
	protected void saveData(class_1799 contentHolder) {
		contentHolder.method_7948()
			.method_10566("Items", ghostInventory.serializeNBT());
	}

	@Override
	protected boolean allowRepeats() {
		return true;
	}

	@Override
	public void method_7593(int slotId, int dragType, class_1713 clickTypeIn, class_1657 player) {
		if (slotId == playerInventory.field_7545 && clickTypeIn != class_1713.field_7795)
			return;
		super.method_7593(slotId, dragType, clickTypeIn, player);
	}

	@Override
	public boolean method_7597(class_1657 playerIn) {
		return playerInventory.method_7391() == contentHolder;
	}

}
