package com.simibubi.create.content.redstone.nixieTube;

import javax.annotation.Nullable;
import net.minecraft.class_1750;
import net.minecraft.class_2350;
import net.minecraft.class_2383;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_2754;
import net.minecraft.class_3542;
import net.minecraft.class_4970;

public class DoubleFaceAttachedBlock extends class_2383 {

	public enum DoubleAttachFace implements class_3542 {
		FLOOR("floor"), WALL("wall"), WALL_REVERSED("wall_reversed"), CEILING("ceiling");

		private final String name;

		private DoubleAttachFace(String p_61311_) {
			this.name = p_61311_;
		}

		public String method_15434() {
			return this.name;
		}

		public int xRot() {
			return this == FLOOR ? 0 : this == CEILING ? 180 : 90;
		}
	}

	public static final class_2754<DoubleAttachFace> FACE =
		class_2754.method_11850("double_face", DoubleAttachFace.class);

	public DoubleFaceAttachedBlock(class_4970.class_2251 p_53182_) {
		super(p_53182_);
	}

	@Nullable
	public class_2680 method_9605(class_1750 pContext) {
		for (class_2350 direction : pContext.method_7718()) {
			class_2680 blockstate;
			if (direction.method_10166() == class_2350.class_2351.field_11052) {
				blockstate = this.method_9564()
					.method_11657(FACE, direction == class_2350.field_11036 ? DoubleAttachFace.CEILING : DoubleAttachFace.FLOOR)
					.method_11657(field_11177, pContext.method_8042());
			} else {
				class_243 n = class_243.method_24954(direction.method_10170()
					.method_10163());
				DoubleAttachFace face = DoubleAttachFace.WALL;
				if (pContext.method_8036() != null) {
					class_243 lookAngle = pContext.method_8036()
						.method_5720();
					if (lookAngle.method_1026(n) < 0)
						face = DoubleAttachFace.WALL_REVERSED;
				}
				blockstate = this.method_9564()
					.method_11657(FACE, face)
					.method_11657(field_11177, direction.method_10153());
			}

			if (blockstate.method_26184(pContext.method_8045(), pContext.method_8037())) {
				return blockstate;
			}
		}

		return null;
	}

	protected static class_2350 getConnectedDirection(class_2680 pState) {
		switch ((DoubleAttachFace) pState.method_11654(FACE)) {
		case CEILING:
			return class_2350.field_11033;
		case FLOOR:
			return class_2350.field_11036;
		default:
			return pState.method_11654(field_11177);
		}
	}
}
