package com.simibubi.create.content.redstone.rail;

import com.simibubi.create.foundation.data.AssetLookup;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2768;
import net.minecraft.class_2769;

public class ControllerRailGenerator extends SpecialBlockStateGen {

	@Override
	protected class_2769<?>[] getIgnoredProperties() {
		return new class_2769<?>[] { ControllerRailBlock.POWER };
	}

	@Override
	protected int getXRotation(class_2680 state) {
		return 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		class_2768 shape = state.method_11654(ControllerRailBlock.SHAPE);
		boolean backwards = ControllerRailBlock.isStateBackwards(state);
		int rotation = backwards ? 180 : 0;

		switch (shape) {
		case field_12674:
		case field_12666:
			return rotation + 270;
		case field_12667:
			return rotation + 90;
		case field_12668:
			return rotation + 180;
		default:
			return rotation;
		}
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		class_2768 shape = state.method_11654(ControllerRailBlock.SHAPE);
		boolean backwards = ControllerRailBlock.isStateBackwards(state);

		String model = shape.method_11897() ? backwards ? "ascending_south" : "ascending_north" : "north_south";
		return AssetLookup.partialBaseModel(ctx, prov, model);
	}

}
