package com.simibubi.create.content.schematics;

import java.util.Iterator;
import net.minecraft.class_1792;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2489;
import net.minecraft.class_2497;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2960;
import com.simibubi.create.AllEntityTypes;
import com.simibubi.create.content.contraptions.glue.SuperGlueEntity;
import com.simibubi.create.foundation.utility.NBTHelper;
import com.simibubi.create.foundation.utility.RegisteredObjects;

public class SchematicAndQuillItem extends class_1792 {

	public SchematicAndQuillItem(class_1793 properties) {
		super(properties);
	}

	public static void replaceStructureVoidWithAir(class_2487 nbt) {
		String air = RegisteredObjects.getKeyOrThrow(class_2246.field_10124)
			.toString();
		String structureVoid = RegisteredObjects.getKeyOrThrow(class_2246.field_10369)
			.toString();

		NBTHelper.iterateCompoundList(nbt.method_10554("palette", 10), c -> {
			if (c.method_10545("Name") && c.method_10558("Name")
				.equals(structureVoid)) {
				c.method_10582("Name", air);
			}
		});
	}

	public static void clampGlueBoxes(class_1937 level, class_238 aabb, class_2487 nbt) {
		class_2499 listtag = nbt.method_10554("entities", 10)
			.method_10612();

		for (Iterator<class_2520> iterator = listtag.iterator(); iterator.hasNext();) {
			class_2520 tag = iterator.next();
			if (!(tag instanceof class_2487 compoundtag))
				continue;
			if (compoundtag.method_10545("nbt") && new class_2960(compoundtag.method_10562("nbt")
				.method_10558("id")).equals(AllEntityTypes.SUPER_GLUE.getId())) {
				iterator.remove();
			}
		}

		for (SuperGlueEntity entity : SuperGlueEntity.collectCropped(level, aabb)) {
			class_243 vec3 = new class_243(entity.method_23317() - aabb.field_1323, entity.method_23318() - aabb.field_1322, entity.method_23321() - aabb.field_1321);
			class_2487 compoundtag = new class_2487();
			entity.method_5662(compoundtag);
			class_2338 blockpos = class_2338.method_49638(vec3);

			class_2487 entityTag = new class_2487();
			entityTag.method_10566("pos", newDoubleList(vec3.field_1352, vec3.field_1351, vec3.field_1350));
			entityTag.method_10566("blockPos", newIntegerList(blockpos.method_10263(), blockpos.method_10264(), blockpos.method_10260()));
			entityTag.method_10566("nbt", compoundtag.method_10553());
			listtag.add(entityTag);
		}

		nbt.method_10566("entities", listtag);
	}

	private static class_2499 newIntegerList(int... pValues) {
		class_2499 listtag = new class_2499();
		for (int i : pValues)
			listtag.add(class_2497.method_23247(i));
		return listtag;
	}

	private static class_2499 newDoubleList(double... pValues) {
		class_2499 listtag = new class_2499();
		for (double d0 : pValues)
			listtag.add(class_2489.method_23241(d0));
		return listtag;
	}

}
