package com.simibubi.create.content.schematics.cannon;

import javax.annotation.Nullable;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3222;
import net.minecraft.class_3532;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.item.ItemHelper;

import io.github.fabricators_of_create.porting_lib.util.NetworkHooks;

public class SchematicannonBlock extends class_2248 implements IBE<SchematicannonBlockEntity> {

	public SchematicannonBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.SCHEMATICANNON_SHAPE;
	}

	@Override
	public void method_9567(class_1937 level, class_2338 pos, class_2680 state, @Nullable class_1309 entity, class_1799 stack) {
		if (entity != null) {
			withBlockEntityDo(level, pos, be -> {
				be.defaultYaw = (-class_3532.method_15375((entity.method_36454() + (entity.method_5715() ? 180.0F : 0.0F)) * 16.0F / 360.0F + 0.5F) & 15) * 360.0F / 16.0F;
			});
		}
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
			class_3965 hit) {
		if (worldIn.field_9236)
			return class_1269.field_5812;
		withBlockEntityDo(worldIn, pos,
				be -> NetworkHooks.openScreen((class_3222) player, be, be::sendToMenu));
		return class_1269.field_5812;
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
			boolean isMoving) {
		withBlockEntityDo(worldIn, pos, be -> be.neighbourCheckCooldown = 0);
	}

	@Override
	public void method_9536(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (!state.method_31709() || state.method_26204() == newState.method_26204())
			return;

		withBlockEntityDo(worldIn, pos, be -> ItemHelper.dropContents(worldIn, pos, be.inventory));
		worldIn.method_8544(pos);
	}

	@Override
	public Class<SchematicannonBlockEntity> getBlockEntityClass() {
		return SchematicannonBlockEntity.class;
	}

	@Override
	public class_2591<? extends SchematicannonBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.SCHEMATICANNON.get();
	}

}
