package com.simibubi.create.content.schematics.cannon;

import com.simibubi.create.AllMenuTypes;
import com.simibubi.create.foundation.gui.menu.MenuBase;
import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_310;
import net.minecraft.class_3917;
import net.minecraft.class_638;

public class SchematicannonMenu extends MenuBase<SchematicannonBlockEntity> {

	public SchematicannonMenu(class_3917<?> type, int id, class_1661 inv, class_2540 buffer) {
		super(type, id, inv, buffer);
	}

	public SchematicannonMenu(class_3917<?> type, int id, class_1661 inv, SchematicannonBlockEntity be) {
		super(type, id, inv, be);
	}

	public static SchematicannonMenu create(int id, class_1661 inv, SchematicannonBlockEntity be) {
		return new SchematicannonMenu(AllMenuTypes.SCHEMATICANNON.get(), id, inv, be);
	}

	@Override
	protected SchematicannonBlockEntity createOnClient(class_2540 extraData) {
		class_638 world = class_310.method_1551().field_1687;
		class_2586 blockEntity = world.method_8321(extraData.method_10811());
		if (blockEntity instanceof SchematicannonBlockEntity schematicannon) {
			schematicannon.readClient(extraData.method_10798());
			return schematicannon;
		}
		return null;
	}

	@Override
	protected void initAndReadInventory(SchematicannonBlockEntity contentHolder) {
	}

	@Override
	protected void addSlots() {
		int x = 0;
		int y = 0;

		method_7621(new SlotItemHandler(contentHolder.inventory, 0, x + 15, y + 65));
		method_7621(new SlotItemHandler(contentHolder.inventory, 1, x + 171, y + 65));
		method_7621(new SlotItemHandler(contentHolder.inventory, 2, x + 134, y + 19));
		method_7621(new SlotItemHandler(contentHolder.inventory, 3, x + 174, y + 19));
		method_7621(new SlotItemHandler(contentHolder.inventory, 4, x + 15, y + 19));

		addPlayerSlots(37, 161);
	}

	@Override
	protected void saveData(SchematicannonBlockEntity contentHolder) {
	}

	@Override
	public class_1799 method_7601(class_1657 playerIn, int index) {
		class_1735 clickedSlot = method_7611(index);
		if (!clickedSlot.method_7681())
			return class_1799.field_8037;
		class_1799 stack = clickedSlot.method_7677();

		if (index < 5) {
			method_7616(stack, 5, field_7761.size(), false);
		} else {
			if (method_7616(stack, 0, 1, false) || method_7616(stack, 2, 3, false)
					|| method_7616(stack, 4, 5, false))
				;
		}

		return class_1799.field_8037;
	}

}
