package com.simibubi.create.content.schematics.packet;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class InstantSchematicPacket extends SimplePacketBase {

	private String name;
	private class_2338 origin;
	private class_2338 bounds;

	public InstantSchematicPacket(String name, class_2338 origin, class_2338 bounds) {
		this.name = name;
		this.origin = origin;
		this.bounds = bounds;
	}

	public InstantSchematicPacket(class_2540 buffer) {
		name = buffer.method_10800(32767);
		origin = buffer.method_10811();
		bounds = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10814(name);
		buffer.method_10807(origin);
		buffer.method_10807(bounds);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			Create.SCHEMATIC_RECEIVER.handleInstantSchematic(player, name, player.method_37908(), origin, bounds);
		});
		return true;
	}

}
