package com.simibubi.create.content.schematics.table;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.item.ItemHelper;

import io.github.fabricators_of_create.porting_lib.util.NetworkHooks;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2383;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_3222;
import net.minecraft.class_3726;
import net.minecraft.class_3965;

public class SchematicTableBlock extends class_2383 implements IBE<SchematicTableBlockEntity> {

	public SchematicTableBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(field_11177);
		super.method_9515(builder);
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		return this.method_9564().method_11657(field_11177, context.method_8042().method_10153());
	}

	@Override
	public class_265 method_9549(class_2680 state, class_1922 worldIn, class_2338 pos,
			class_3726 context) {
		return AllShapes.TABLE_POLE_SHAPE;
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.SCHEMATICS_TABLE.get(state.method_11654(field_11177));
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
			class_3965 hit) {
		if (worldIn.field_9236)
			return class_1269.field_5812;
		withBlockEntityDo(worldIn, pos,
				be -> NetworkHooks.openScreen((class_3222) player, be, be::sendToMenu));
		return class_1269.field_5812;
	}

	@Override
	public void method_9536(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (!state.method_31709() || state.method_26204() == newState.method_26204())
			return;

		withBlockEntityDo(worldIn, pos, be -> ItemHelper.dropContents(worldIn, pos, be.inventory));
		worldIn.method_8544(pos);
	}

	@Override
	public Class<SchematicTableBlockEntity> getBlockEntityClass() {
		return SchematicTableBlockEntity.class;
	}

	@Override
	public class_2591<? extends SchematicTableBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.SCHEMATIC_TABLE.get();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
