package com.simibubi.create.content.trains.bogey;

import com.simibubi.create.foundation.blockEntity.renderer.SafeBlockEntityRenderer;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;

public class BogeyBlockEntityRenderer<T extends class_2586> extends SafeBlockEntityRenderer<T> {

	public BogeyBlockEntityRenderer(class_5614.class_5615 context) {}

	@Override
	protected void renderSafe(T be, float partialTicks, class_4587 ms, class_4597 buffer, int light,
		int overlay) {
		class_2680 blockState = be.method_11010();
		if (be instanceof AbstractBogeyBlockEntity sbbe) {
			float angle = sbbe.getVirtualAngle(partialTicks);
			if (blockState.method_26204() instanceof AbstractBogeyBlock<?> bogey)
				bogey.render(blockState, angle, ms, partialTicks, buffer, light, overlay, sbbe.getStyle(), sbbe.getBogeyData());
		}
	}

}
