package com.simibubi.create.content.trains.observer;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.content.trains.track.ITrackBlock;
import com.simibubi.create.content.trains.track.TrackTargetingBehaviour;
import com.simibubi.create.content.trains.track.TrackTargetingBehaviour.RenderedTrackOverlayType;
import com.simibubi.create.foundation.blockEntity.renderer.SmartBlockEntityRenderer;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614.class_5615;

public class TrackObserverRenderer extends SmartBlockEntityRenderer<TrackObserverBlockEntity> {

	public TrackObserverRenderer(class_5615 context) {
		super(context);
	}

	@Override
	protected void renderSafe(TrackObserverBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		super.renderSafe(be, partialTicks, ms, buffer, light, overlay);
		class_2338 pos = be.method_11016();

		TrackTargetingBehaviour<TrackObserver> target = be.edgePoint;
		class_2338 targetPosition = target.getGlobalPosition();
		class_1937 level = be.method_10997();
		class_2680 trackState = level.method_8320(targetPosition);
		class_2248 block = trackState.method_26204();

		if (!(block instanceof ITrackBlock))
			return;

		ms.method_22903();
		TransformStack.cast(ms)
			.translate(targetPosition.method_10059(pos));
		RenderedTrackOverlayType type = RenderedTrackOverlayType.OBSERVER;
		TrackTargetingBehaviour.render(level, targetPosition, target.getTargetDirection(), target.getTargetBezier(), ms,
			buffer, light, overlay, type, 1);
		ms.method_22909();

	}

}
