package com.simibubi.create.content.trains.schedule;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_342;
import net.minecraft.class_3532;
import net.minecraft.class_437;
import net.minecraft.class_4717;
import com.mojang.brigadier.context.StringRange;
import com.mojang.brigadier.suggestion.Suggestion;
import com.simibubi.create.foundation.utility.IntAttached;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.CommandSuggestions$SuggestionsListAccessor;
import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.CommandSuggestions.SuggestionsListAccessor;

public class DestinationSuggestions extends class_4717 {

	private class_342 textBox;
	private List<IntAttached<String>> viableStations;
	private String previous = "<>";
	private class_327 font;
	private boolean active;

	List<Suggestion> currentSuggestions;
	private int yOffset;

	public DestinationSuggestions(class_310 pMinecraft, class_437 pScreen, class_342 pInput, class_327 pFont,
		List<IntAttached<String>> viableStations, int yOffset) {
		super(pMinecraft, pScreen, pInput, pFont, true, true, 0, 7, false, 0xee_303030);
		this.textBox = pInput;
		this.font = pFont;
		this.viableStations = viableStations;
		this.yOffset = yOffset;
		currentSuggestions = new ArrayList<>();
		active = false;
	}

	public void tick() {
		if (field_21612 == null)
			textBox.method_1887("");
		if (active == textBox.method_25370())
			return;
		active = textBox.method_25370();
		method_23934();
	}

	@Override
	public void method_23934() {
		String value = this.textBox.method_1882();
		if (value.equals(previous))
			return;
		if (!active) {
			field_21612 = null;
			return;
		}

		previous = value;
		currentSuggestions = viableStations.stream()
			.filter(ia -> !ia.getValue()
				.equals(value) && ia.getValue()
					.toLowerCase()
					.startsWith(value.toLowerCase()))
			.sorted((ia1, ia2) -> Long.compare(ia1.getFirst(), ia2.getFirst()))
			.map(IntAttached::getValue)
			.map(s -> new Suggestion(new StringRange(0, s.length()), s))
			.toList();

		method_23920(false);
	}

	public void method_23920(boolean pNarrateFirstSuggestion) {
		if (currentSuggestions.isEmpty()) {
			field_21612 = null;
			return;
		}

		int width = 0;
		for (Suggestion suggestion : currentSuggestions)
			width = Math.max(width, this.font.method_1727(suggestion.getText()));
		int x = class_3532.method_15340(textBox.method_1889(0), 0, textBox.method_1889(0) + textBox.method_1859() - width);
		field_21612 = SuggestionsListAccessor.port_lib$create(this, x, 72 + yOffset, width, currentSuggestions, false);
	}

}
