package com.simibubi.create.content.trains.schedule;

import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class ScheduleEditPacket extends SimplePacketBase {

	private Schedule schedule;

	public ScheduleEditPacket(Schedule schedule) {
		this.schedule = schedule;
	}

	public ScheduleEditPacket(class_2540 buffer) {
		schedule = Schedule.fromTag(buffer.method_10798());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10794(schedule.write());
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			class_1799 mainHandItem = sender.method_6047();
			if (!AllItems.SCHEDULE.isIn(mainHandItem))
				return;
			
			class_2487 tag = mainHandItem.method_7948();
			if (schedule.entries.isEmpty()) {
				tag.method_10551("Schedule");
				if (tag.method_33133())
					mainHandItem.method_7980(null);
			} else
				tag.method_10566("Schedule", schedule.write());
			
			sender.method_7357()
				.method_7906(mainHandItem.method_7909(), 5);
		});
		return true;
	}

}
