package com.simibubi.create.content.trains.schedule;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import com.simibubi.create.content.trains.schedule.condition.ScheduleWaitCondition;
import com.simibubi.create.content.trains.schedule.destination.ScheduleInstruction;
import com.simibubi.create.foundation.utility.NBTHelper;

public class ScheduleEntry {
	public ScheduleInstruction instruction;
	public List<List<ScheduleWaitCondition>> conditions;

	public ScheduleEntry() {
		conditions = new ArrayList<>();
	}

	public ScheduleEntry clone() {
		return fromTag(write());
	}

	public class_2487 write() {
		class_2487 tag = new class_2487();
		class_2499 outer = new class_2499();
		tag.method_10566("Instruction", instruction.write());
		if (!instruction.supportsConditions())
			return tag;
		for (List<ScheduleWaitCondition> column : conditions)
			outer.add(NBTHelper.writeCompoundList(column, ScheduleWaitCondition::write));
		tag.method_10566("Conditions", outer);
		return tag;
	}

	public static ScheduleEntry fromTag(class_2487 tag) {
		ScheduleEntry entry = new ScheduleEntry();
		entry.instruction = ScheduleInstruction.fromTag(tag.method_10562("Instruction"));
		entry.conditions = new ArrayList<>();
		if (entry.instruction.supportsConditions())
			for (class_2520 t : tag.method_10554("Conditions", class_2520.field_33259))
				if (t instanceof class_2499 list)
					entry.conditions.add(NBTHelper.readCompoundList(list, ScheduleWaitCondition::fromTag));
		return entry;
	}

}