package com.simibubi.create.content.trains.schedule.condition;

import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2960;

public class ScheduledDelay extends TimedWaitCondition {

	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(class_1799.field_8037, Lang.translateDirect("schedule.condition.delay_short", formatTime(true)));
	}

	@Override
	public boolean tickCompletion(class_1937 level, Train train, class_2487 context) {
		int time = context.method_10550("Time");
		if (time >= totalWaitTicks())
			return true;
		
		context.method_10569("Time", time + 1);
		requestDisplayIfNecessary(context, time);
		return false;
	}

	@Override
	public class_2960 getId() {
		return Create.asResource("delay");
	}

}