package com.simibubi.create.content.trains.schedule.destination;

import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import com.google.common.collect.ImmutableList;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;

public class ChangeTitleInstruction extends TextScheduleInstruction {

	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(icon(), Components.literal(getLabelText()));
	}

	@Override
	public class_2960 getId() {
		return Create.asResource("rename");
	}

	@Override
	public class_1799 getSecondLineIcon() {
		return icon();
	}

	@Override
	public boolean supportsConditions() {
		return false;
	}
	
	public String getScheduleTitle() {
		return getLabelText();
	}

	private class_1799 icon() {
		return new class_1799(class_1802.field_8448);
	}

	@Override
	public List<class_2561> getSecondLineTooltip(int slot) {
		return ImmutableList.of(Lang.translateDirect("schedule.instruction.name_edit_box"),
			Lang.translateDirect("schedule.instruction.name_edit_box_1")
				.method_27692(class_124.field_1080),
			Lang.translateDirect("schedule.instruction.name_edit_box_2")
				.method_27692(class_124.field_1063));
	}

}
