package com.simibubi.create.content.trains.track;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2680;

public class TrackBlockStateGenerator extends SpecialBlockStateGen {

	@Override
	protected int getXRotation(class_2680 state) {
		return 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		return state.method_11654(TrackBlock.SHAPE)
			.getModelRotation();
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		TrackShape value = state.method_11654(TrackBlock.SHAPE);
		if (value == TrackShape.NONE)
			return prov.models()
				.getExistingFile(prov.mcLoc("block/air"));
		return prov.models()
			.getExistingFile(Create.asResource("block/track/" + value.getModel()));
	}

}
