package com.simibubi.create.foundation.config.ui;

import io.github.fabricators_of_create.porting_lib.util.KeyBindingHelper;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_332;
import net.minecraft.class_342;
import net.minecraft.class_3675;
import org.lwjgl.glfw.GLFW;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.utility.Components;

public class HintableTextFieldWidget extends class_342 {

	protected class_327 font;
	protected String hint;

	public HintableTextFieldWidget(class_327 font, int x, int y, int width, int height) {
		super(font, x, y, width, height, Components.immutableEmpty());
		this.font = font;
	}

	public void setHint(String hint) {
		this.hint = hint;
	}

	@Override
	public void method_48579(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		super.method_48579(graphics, mouseX, mouseY, partialTicks);

		if (hint == null || hint.isEmpty())
			return;

		if (!method_1882().isEmpty())
			return;

		graphics.method_51433(font, hint, method_46426() + 5, this.method_46427() + (this.field_22759 - 8) / 2, Theme.c(Theme.Key.TEXT).scaleAlpha(.75f).getRGB(), false);
	}

	@Override
	public boolean method_25402(double x, double y, int button) {
		if (!method_25405(x, y))
			return false;

		if (button == GLFW.GLFW_MOUSE_BUTTON_RIGHT) {
			method_1852("");
			return true;
		} else
			return super.method_25402(x, y, button);
	}

	@Override
	public boolean method_25404(int code, int p_keyPressed_2_, int p_keyPressed_3_) {
		class_3675.class_306 mouseKey = class_3675.method_15985(code, p_keyPressed_2_);
		if (KeyBindingHelper.isActiveAndMatches(class_310.method_1551().field_1690.field_1822, mouseKey)) {
			return true;
		}

		return super.method_25404(code, p_keyPressed_2_, p_keyPressed_3_);
	}
}
