package com.simibubi.create.foundation.gui.element;

import org.lwjgl.opengl.GL11;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public abstract class StencilElement extends RenderElement {

	@Override
	public void render(class_332 graphics) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		transform(ms);
		prepareStencil(ms);
		renderStencil(graphics);
		prepareElement(ms);
		renderElement(graphics);
		cleanUp(ms);
		ms.method_22909();
	}

	protected abstract void renderStencil(class_332 graphics);

	protected abstract void renderElement(class_332 graphics);

	protected void transform(class_4587 ms) {
		ms.method_46416(x, y, z);
	}

	protected void prepareStencil(class_4587 ms) {
		GL11.glDisable(GL11.GL_STENCIL_TEST);
		RenderSystem.stencilMask(~0);
		RenderSystem.clear(GL11.GL_STENCIL_BUFFER_BIT, class_310.field_1703);
		GL11.glEnable(GL11.GL_STENCIL_TEST);
		RenderSystem.stencilOp(GL11.GL_REPLACE, GL11.GL_KEEP, GL11.GL_KEEP);
		RenderSystem.stencilMask(0xFF);
		RenderSystem.stencilFunc(GL11.GL_NEVER, 1, 0xFF);
	}

	protected void prepareElement(class_4587 ms) {
		GL11.glEnable(GL11.GL_STENCIL_TEST);
		RenderSystem.stencilOp(GL11.GL_KEEP, GL11.GL_KEEP, GL11.GL_KEEP);
		RenderSystem.stencilFunc(GL11.GL_EQUAL, 1, 0xFF);
	}

	protected void cleanUp(class_4587 ms) {
		GL11.glDisable(GL11.GL_STENCIL_TEST);

	}
}
