package com.simibubi.create.foundation.mixin.client;

import java.util.Iterator;
import net.minecraft.class_20;
import net.minecraft.class_22;
import net.minecraft.class_330;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import org.joml.Matrix4f;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;
import com.simibubi.create.foundation.map.CustomRenderedMapDecoration;

// fabric: we have an AW for it, and compiler complains if specified by string
@Mixin(value = class_330.class_331.class, priority = 1100) // apply after porting lib's current busted mixin here
public class MapRendererMapInstanceMixin {
	@Shadow
	private class_22 data;

//	@Group(name = "custom_decoration_rendering", min = 1, max = 1)
	@Inject(method = "draw(Lcom/mojang/blaze3d/vertex/PoseStack;Lnet/minecraft/client/renderer/MultiBufferSource;ZI)V", at = @At(value = "INVOKE", target = "Lcom/mojang/blaze3d/vertex/PoseStack;pushPose()V", ordinal = 0), locals = LocalCapture.CAPTURE_FAILHARD)
	private void onDraw(class_4587 poseStack, class_4597 bufferSource, boolean active, int packedLight, CallbackInfo ci, int i, int j, float f, Matrix4f matrix4f, class_4588 vertexConsumer, int index, Iterator<class_20> iterator, class_20 decoration) {
		if (decoration instanceof CustomRenderedMapDecoration renderer) {
			renderer.render(poseStack, bufferSource, active, packedLight, data, index);
		}
	}

	// fabric: optifine is not supported
//	@Group(name = "custom_decoration_rendering")
//	@Inject(method = "draw(Lcom/mojang/blaze3d/vertex/PoseStack;Lnet/minecraft/client/renderer/MultiBufferSource;ZI)V", at = @At(value = "FIELD", target = "net/optifine/reflect/Reflector.ForgeMapDecoration_render:Lnet/optifine/reflect/ReflectorMethod;", opcode = Opcodes.GETSTATIC, ordinal = 1, remap = false), locals = LocalCapture.CAPTURE_FAILHARD)
//	private void onDrawOptifine(PoseStack poseStack, MultiBufferSource bufferSource, boolean active, int packedLight, CallbackInfo ci, int i, int j, float f, Matrix4f matrix4f, VertexConsumer vertexConsumer, int index, Iterator<MapDecoration> iterator, MapDecoration decoration) {
//		if (decoration instanceof CustomRenderedMapDecoration renderer) {
//			renderer.render(poseStack, bufferSource, active, packedLight, data, index);
//		}
//	}
}
