package com.simibubi.create.foundation.mixin.client;

import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import com.simibubi.create.foundation.gui.UIRenderHelper;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1041;
import net.minecraft.class_310;

@Mixin(class_310.class)
public class WindowResizeMixin {
	@Shadow
	@Final
	private class_1041 window;

	@Inject(method = "resizeDisplay()V", at = @At("TAIL"))
	private void create$updateWindowSize(CallbackInfo ci) {
		UIRenderHelper.updateWindowSize(window);
	}
}
