package com.simibubi.create.infrastructure.command;

import static net.minecraft.class_2170.method_9247;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.infrastructure.debugInfo.ServerDebugInfoPacket;
import net.minecraft.class_2168;
import net.minecraft.class_3222;

public class DebugInfoCommand {
	public static ArgumentBuilder<class_2168, ?> register() {
		return method_9247("debuginfo").executes(ctx -> {
			class_2168 source = ctx.getSource();
			class_3222 player = source.method_9207();

			Lang.translate("command.debuginfo.sending")
				.sendChat(player);
			AllPackets.getChannel()
					.sendToClient(new ServerDebugInfoPacket(player), player);

			return Command.SINGLE_SUCCESS;
		});
	}
}
