package com.simibubi.create.infrastructure.command;

import com.mojang.brigadier.arguments.IntegerArgumentType;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.utility.Lang;
import net.minecraft.class_2168;
import net.minecraft.class_2170;

public class KillTPSCommand {

	public static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("killtps")
			.requires(cs -> cs.method_9259(2))
			.executes(ctx -> {
				// killtps no arguments
				ctx.getSource()
					.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.slowed_by.0",
						Create.LAGGER.isLagging() ? Create.LAGGER.getTickTime() : 0), true);
				if (Create.LAGGER.isLagging())
					ctx.getSource()
						.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.usage.0"), true);
				else
					ctx.getSource()
						.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.usage.1"), true);

				return 1;
			})
			.then(class_2170.method_9247("start")
				.executes(ctx -> {
					// killtps start no time
					int tickTime = Create.LAGGER.getTickTime();
					if (tickTime > 0) {
						Create.LAGGER.setLagging(true);
						ctx.getSource()
							.method_9226(() -> (Lang.translateDirect("command.killTPSCommand.status.slowed_by.1", tickTime)),
								true);
						ctx.getSource()
							.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.usage.0"), true);
					} else {
						ctx.getSource()
							.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.usage.1"), true);
					}

					return 1;
				})
				.then(class_2170.method_9244(Lang.translateDirect("command.killTPSCommand.argument.tickTime")
					.getString(), IntegerArgumentType.integer(1))
					.executes(ctx -> {
						// killtps start tickTime
						int tickTime = IntegerArgumentType.getInteger(ctx,
							Lang.translateDirect("command.killTPSCommand.argument.tickTime")
								.getString());
						Create.LAGGER.setTickTime(tickTime);
						Create.LAGGER.setLagging(true);
						ctx.getSource()
							.method_9226(() -> (Lang.translateDirect("command.killTPSCommand.status.slowed_by.1", tickTime)),
								true);
						ctx.getSource()
							.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.usage.0"), true);

						return 1;
					})))
			.then(class_2170.method_9247("stop")
				.executes(ctx -> {
					// killtps stop
					Create.LAGGER.setLagging(false);
					ctx.getSource()
						.method_9226(() -> Lang.translateDirect("command.killTPSCommand.status.slowed_by.2"), false);

					return 1;
				}));
	}
}
