package com.simibubi.create.infrastructure.command;

import java.util.UUID;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_5242;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.foundation.utility.Components;

public class KillTrainCommand {

	static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("killTrain")
			.requires(cs -> cs.method_9259(2))
			.then(class_2170.method_9244("train", class_5242.method_27643())
				.executes(ctx -> {
					class_2168 source = ctx.getSource();
					run(source, class_5242.method_27645(ctx, "train"));
					return 1;
				}));
	}

	private static void run(class_2168 source, UUID argument) {
		Train train = Create.RAILWAYS.trains.get(argument);
		if (train == null) {
			source.method_9213(Components.literal("No Train with id " + argument.toString()
				.substring(0, 5) + "[...] was found"));
			return;
		}

		train.invalid = true;
		source.method_9226(() -> Components.literal("Train '").method_10852(train.name)
			.method_27693("' removed successfully"), true);
	}

}
