package com.simibubi.create.infrastructure.worldgen;

import static net.minecraft.class_6817.method_40370;

import java.util.List;
import net.minecraft.class_2975;
import net.minecraft.class_5321;
import net.minecraft.class_5450;
import net.minecraft.class_5843;
import net.minecraft.class_6793;
import net.minecraft.class_6795;
import net.minecraft.class_6796;
import net.minecraft.class_6797;
import net.minecraft.class_6799;
import net.minecraft.class_6880;
import net.minecraft.class_7871;
import net.minecraft.class_7891;
import net.minecraft.class_7924;
import com.simibubi.create.Create;

public class AllPlacedFeatures {
	public static final class_5321<class_6796>
				ZINC_ORE = key("zinc_ore"),
				STRIATED_ORES_OVERWORLD = key("striated_ores_overworld"),
				STRIATED_ORES_NETHER = key("striated_ores_nether");
	
	private static class_5321<class_6796> key(String name) {
		return class_5321.method_29179(class_7924.field_41245, Create.asResource(name));
	}

	public static void bootstrap(class_7891<class_6796> ctx) {
		class_7871<class_2975<?, ?>> featureLookup = ctx.method_46799(class_7924.field_41239);
		class_6880<class_2975<?, ?>> zincOre = featureLookup.method_46747(AllConfiguredFeatures.ZINC_ORE);
		class_6880<class_2975<?, ?>> striatedOresOverworld = featureLookup.method_46747(AllConfiguredFeatures.STRIATED_ORES_OVERWORLD);
		class_6880<class_2975<?, ?>> striatedOresNether = featureLookup.method_46747(AllConfiguredFeatures.STRIATED_ORES_NETHER);

		method_39737(ctx, ZINC_ORE, zincOre, placement(class_6793.method_39623(8), -63, 70));
		method_39737(ctx, STRIATED_ORES_OVERWORLD, striatedOresOverworld, placement(class_6799.method_39659(18), -30, 70));
		method_39737(ctx, STRIATED_ORES_NETHER, striatedOresNether, placement(class_6799.method_39659(18), 40, 90));
	}

	private static List<class_6797> placement(class_6797 frequency, int minHeight, int maxHeight) {
		return List.of(
				frequency,
				class_5450.method_39639(),
				class_6795.method_39634(class_5843.method_33841(minHeight), class_5843.method_33841(maxHeight)),
				ConfigPlacementFilter.INSTANCE
		);
	}
}
