package com.simibubi.create.compat.jei;

import java.util.function.Supplier;

import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import mezz.jei.api.gui.drawable.IDrawable;
import net.minecraft.class_1799;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class ItemIcon implements IDrawable {

	private Supplier<class_1799> supplier;
	private class_1799 stack;

	public ItemIcon(Supplier<class_1799> stack) {
		this.supplier = stack;
	}

	@Override
	public int getWidth() {
		return 18;
	}

	@Override
	public int getHeight() {
		return 18;
	}

	@Override
	public void draw(class_332 graphics, int xOffset, int yOffset) {
		class_4587 matrixStack = graphics.method_51448();
		if (stack == null) {
			stack = supplier.get();
		}

		RenderSystem.enableDepthTest();
		matrixStack.method_22903();
		matrixStack.method_46416(xOffset + 1, yOffset + 1, 0);

		GuiGameElement.of(stack)
			.render(graphics);

		matrixStack.method_22909();
	}


}
