package com.simibubi.create.compat.jei;

import com.simibubi.create.foundation.gui.AllGuiTextures;

import mezz.jei.api.gui.drawable.IDrawable;
import net.minecraft.class_332;

public class ScreenResourceWrapper implements IDrawable {

	private AllGuiTextures resource;

	public ScreenResourceWrapper(AllGuiTextures resource) {
		this.resource = resource;
	}

	@Override
	public int getWidth() {
		return resource.width;
	}

	@Override
	public int getHeight() {
		return resource.height;
	}

	@Override
	public void draw(class_332 graphics, int xOffset, int yOffset) {
		graphics.method_25291(resource.location, xOffset, yOffset, 0, resource.startX, resource.startY, resource.width,
			resource.height, 256, 256);
	}

}
