package com.simibubi.create.compat.rei;

import java.util.function.Supplier;

import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import me.shedaniel.math.Rectangle;
import me.shedaniel.rei.api.client.gui.Renderer;
import net.minecraft.class_1799;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class ItemIcon implements Renderer {

	private Supplier<class_1799> supplier;
	private class_1799 stack;

	public ItemIcon(Supplier<class_1799> stack) {
		this.supplier = stack;
	}

	@Override
	public void render(class_332 graphics, Rectangle bounds, int mouseX, int mouseY, float delta) {
		if (stack == null) {
			stack = supplier.get();
		}

		int xOffset = bounds.x;
		int yOffset = bounds.y;

		class_4587 matrixStack = graphics.method_51448();
		RenderSystem.enableDepthTest();
		matrixStack.method_22903();
		matrixStack.method_46416(xOffset, yOffset, 0);

		GuiGameElement.of(stack)
				.render(graphics);

		matrixStack.method_22909();
	}
}
