package com.simibubi.create.compat.rei;

import java.util.List;
import net.minecraft.class_1293;
import net.minecraft.class_1842;
import net.minecraft.class_1844;
import net.minecraft.class_2487;
import com.simibubi.create.content.fluids.potion.PotionFluid.BottleType;
import com.simibubi.create.foundation.utility.NBTHelper;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

/* From JEI's Potion item subtype interpreter */
public class PotionFluidSubtypeInterpreter /*implements IIngredientSubtypeInterpreter<FluidStack>*/ {

//	@Override
	public String apply(FluidStack ingredient) {
		if (!ingredient.hasTag())
			return "";

		class_2487 tag = ingredient.getOrCreateTag();
		class_1842 potionType = class_1844.method_8057(tag);
		String potionTypeString = potionType.method_8051("");
		String bottleType = NBTHelper.readEnum(tag, "Bottle", BottleType.class)
			.toString();

		StringBuilder stringBuilder = new StringBuilder(potionTypeString);
		List<class_1293> effects = class_1844.method_8060(tag);

		stringBuilder.append(";")
			.append(bottleType);
		for (class_1293 effect : potionType.method_8049())
			stringBuilder.append(";")
				.append(effect);
		for (class_1293 effect : effects)
			stringBuilder.append(";")
				.append(effect);
		return stringBuilder.toString();
	}

}
