package com.simibubi.create.content.contraptions.behaviour.dispenser;

import javax.annotation.Nullable;

import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import net.minecraft.class_2338;
import net.minecraft.class_2342;
import net.minecraft.class_2350;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_3218;
import net.minecraft.class_6328;
import net.minecraft.server.MinecraftServer;

@class_6328
public class ContraptionBlockSource implements class_2342 {
	private final class_2338 pos;
	private final MovementContext context;
	private final class_2350 overrideFacing;

	public ContraptionBlockSource(MovementContext context, class_2338 pos) {
		this(context, pos, null);
	}

	public ContraptionBlockSource(MovementContext context, class_2338 pos, @Nullable class_2350 overrideFacing) {
		this.pos = pos;
		this.context = context;
		this.overrideFacing = overrideFacing;
	}

	@Override
	public double method_10216() {
		return (double)this.pos.method_10263() + 0.5D;
	}

	@Override
	public double method_10214() {
		return (double)this.pos.method_10264() + 0.5D;
	}

	@Override
	public double method_10215() {
		return (double)this.pos.method_10260() + 0.5D;
	}

	@Override
	public class_2338 method_10122() {
		return pos;
	}

	@Override
	public class_2680 method_10120() {
		if (context.state.method_28498(class_2741.field_12525) && overrideFacing != null)
			return context.state.method_11657(class_2741.field_12525, overrideFacing);
		return context.state;
	}

	@Override
	@Nullable
	public <T extends class_2586> T method_10121() {
		return null;
	}

	@Override
	@Nullable
	public class_3218 method_10207() {
		MinecraftServer server = context.world.method_8503();
		return server != null ? server.method_3847(context.world.method_27983()) : null;
	}
}
