package com.simibubi.create.content.contraptions.elevator;

import com.simibubi.create.content.decoration.slidingDoor.DoorControl;
import com.simibubi.create.foundation.networking.BlockEntityConfigurationPacket;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_3532;

public class ElevatorContactEditPacket extends BlockEntityConfigurationPacket<ElevatorContactBlockEntity> {

	private String shortName;
	private String longName;
	private DoorControl doorControl;

	public ElevatorContactEditPacket(class_2338 pos, String shortName, String longName, DoorControl doorControl) {
		super(pos);
		this.shortName = shortName;
		this.longName = longName;
		this.doorControl = doorControl;
	}

	public ElevatorContactEditPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void writeSettings(class_2540 buffer) {
		buffer.method_10788(shortName, 4);
		buffer.method_10788(longName, 30);
		buffer.method_10804(doorControl.ordinal());
	}

	@Override
	protected void readSettings(class_2540 buffer) {
		shortName = buffer.method_10800(4);
		longName = buffer.method_10800(30);
		doorControl = DoorControl.values()[class_3532.method_15340(buffer.method_10816(), 0, DoorControl.values().length)];
	}

	@Override
	protected void applySettings(ElevatorContactBlockEntity be) {
		be.updateName(shortName, longName);
		be.doorControls.set(doorControl);
	}

}
