package com.simibubi.create.content.contraptions.glue;

import com.simibubi.create.foundation.networking.SimplePacketBase;

import io.github.fabricators_of_create.porting_lib.util.EnvExecutor;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2540;
import net.minecraft.class_310;

public class GlueEffectPacket extends SimplePacketBase {

	private class_2338 pos;
	private class_2350 direction;
	private boolean fullBlock;

	public GlueEffectPacket(class_2338 pos, class_2350 direction, boolean fullBlock) {
		this.pos = pos;
		this.direction = direction;
		this.fullBlock = fullBlock;
	}

	public GlueEffectPacket(class_2540 buffer) {
		pos = buffer.method_10811();
		direction = class_2350.method_10143(buffer.readByte());
		fullBlock = buffer.readBoolean();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(pos);
		buffer.writeByte(direction.method_10146());
		buffer.writeBoolean(fullBlock);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> this::handleClient));
		return true;
	}

	@Environment(EnvType.CLIENT)
	public void handleClient() {
		class_310 mc = class_310.method_1551();
		if (!mc.field_1724.method_24515().method_19771(pos, 100))
			return;
		SuperGlueItem.spawnParticles(mc.field_1687, pos, direction, fullBlock);
	}

}
