package com.simibubi.create.content.contraptions.minecart;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1688;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class CouplingCreationPacket extends SimplePacketBase {

	int id1, id2;

	public CouplingCreationPacket(class_1688 cart1, class_1688 cart2) {
		id1 = cart1.method_5628();
		id2 = cart2.method_5628();
	}

	public CouplingCreationPacket(class_2540 buffer) {
		id1 = buffer.readInt();
		id2 = buffer.readInt();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(id1);
		buffer.writeInt(id2);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			if (sender != null)
				CouplingHandler.tryToCoupleCarts(sender, sender.method_37908(), id1, id2);
		});
		return true;
	}

}
