package com.simibubi.create.content.contraptions.piston;

import com.jozufozu.flywheel.util.box.GridAlignedBB;
import com.simibubi.create.content.contraptions.render.ContraptionLighter;
import net.minecraft.class_2382;

public class PistonLighter extends ContraptionLighter<PistonContraption> {
    public PistonLighter(PistonContraption contraption) {
        super(contraption);
    }

    @Override
    public GridAlignedBB getContraptionBounds() {
        GridAlignedBB bounds = GridAlignedBB.from(contraption.bounds);
        bounds.translate(contraption.anchor);

        int length = contraption.extensionLength;
        class_2382 direction = contraption.orientation.method_10163();

        int shift = length / 2;
        int shiftX = direction.method_10263() * shift;
        int shiftY = direction.method_10264() * shift;
        int shiftZ = direction.method_10260() * shift;
        bounds.translate(shiftX, shiftY, shiftZ);

        int grow = (length + 1) / 2;
        int extendX = Math.abs(direction.method_10263() * grow);
        int extendY = Math.abs(direction.method_10264() * grow);
        int extendZ = Math.abs(direction.method_10260() * grow);
        bounds.grow(extendX, extendY, extendZ);

        return bounds;
    }
}
