package com.simibubi.create.content.contraptions.pulley;

import com.jozufozu.flywheel.util.box.GridAlignedBB;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.contraptions.render.ContraptionLighter;
import net.minecraft.class_1937;
import net.minecraft.class_2338;

public class PulleyLighter extends ContraptionLighter<PulleyContraption> {
    public PulleyLighter(PulleyContraption contraption) {
        super(contraption);
    }

    @Override
    public GridAlignedBB getContraptionBounds() {

        GridAlignedBB bounds = GridAlignedBB.from(contraption.bounds);

        class_1937 world = contraption.entity.method_37908();

        class_2338.class_2339 pos = contraption.anchor.method_25503();
        while (!AllBlocks.ROPE_PULLEY.has(world.method_8320(pos)) && pos.method_10264() < world.method_31600()) 
            pos.method_10100(0, 1, 0);

        bounds.translate(pos);
        bounds.setMinY(world.method_31607());
        return bounds;
    }
}
