package com.simibubi.create.content.contraptions.render;

import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.Contraption;
import net.minecraft.class_2960;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_4604;
import net.minecraft.class_5617;
import net.minecraft.class_897;

public class ContraptionEntityRenderer<C extends AbstractContraptionEntity> extends class_897<C> {

	public ContraptionEntityRenderer(class_5617.class_5618 context) {
		super(context);
	}

	@Override
	public class_2960 getTextureLocation(C entity) {
		return null;
	}

	@Override
	public boolean shouldRender(C entity, class_4604 clippingHelper, double cameraX, double cameraY,
		double cameraZ) {
		if (entity.getContraption() == null)
			return false;
		if (!entity.isAliveOrStale())
			return false;
		if (!entity.isReadyForRender())
			return false;

		return super.method_3933(entity, clippingHelper, cameraX, cameraY, cameraZ);
	}

	@Override
	public void render(C entity, float yaw, float partialTicks, class_4587 ms, class_4597 buffers,
		int overlay) {
		super.method_3936(entity, yaw, partialTicks, ms, buffers, overlay);

		Contraption contraption = entity.getContraption();
		if (contraption != null) {
			ContraptionRenderDispatcher.renderFromEntity(entity, contraption, buffers);
		}
	}

}
