package com.simibubi.create.content.contraptions.sync;

import java.util.function.Supplier;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.simibubi.create.foundation.mixin.fabric.ServerGamePacketListenerImplAccessor;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.networking.SimplePacketBase;

public class ClientMotionPacket extends SimplePacketBase {

	private class_243 motion;
	private boolean onGround;
	private float limbSwing;

	public ClientMotionPacket(class_243 motion, boolean onGround, float limbSwing) {
		this.motion = motion;
		this.onGround = onGround;
		this.limbSwing = limbSwing;
	}

	public ClientMotionPacket(class_2540 buffer) {
		motion = new class_243(buffer.readFloat(), buffer.readFloat(), buffer.readFloat());
		onGround = buffer.readBoolean();
		limbSwing = buffer.readFloat();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeFloat((float) motion.field_1352);
		buffer.writeFloat((float) motion.field_1351);
		buffer.writeFloat((float) motion.field_1350);
		buffer.writeBoolean(onGround);
		buffer.writeFloat(limbSwing);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			if (sender == null)
				return;
			sender.method_18799(motion);
			sender.method_24830(onGround);
			if (onGround) {
				sender.method_5747(sender.field_6017, 1, sender.method_48923().method_48827());
				sender.field_6017 = 0;
				ServerGamePacketListenerImplAccessor access = (ServerGamePacketListenerImplAccessor) sender.field_13987;
					access.create$setAboveGroundTickCount(0);
				access.create$setAboveGroundVehicleTickCount(0);
			}
			AllPackets.getChannel().sendToClientsTracking(new LimbSwingUpdatePacket(sender.method_5628(), sender.method_19538(), limbSwing), sender);
		});
		return true;
	}

}
