package com.simibubi.create.content.decoration.encasing;

import java.util.List;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3965;

/**
 * Implement this interface to indicate that this block is encasable.
 */
public interface EncasableBlock {
	/**
	 * This method should be called in the {@link class_2248#method_9534(class_2680, class_1937, class_2338, class_1657, class_1268, class_3965)} method.
	 */
	default class_1269 tryEncase(class_2680 state, class_1937 level, class_2338 pos, class_1799 heldItem, class_1657 player, class_1268 hand,
		class_3965 ray) {
		List<class_2248> encasedVariants = EncasingRegistry.getVariants(state.method_26204());
		for (class_2248 block : encasedVariants) {
			if (block instanceof EncasedBlock encased) {
				if (encased.getCasing().method_8389() != heldItem.method_7909())
					continue;

				if (level.field_9236)
					return class_1269.field_5812;

				encased.handleEncasing(state, level, pos, heldItem, player, hand, ray);
				return class_1269.field_5812;
			}
		}
		return class_1269.field_5811;
	}
}
