package com.simibubi.create.content.equipment.bell;

import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_2338;
import net.minecraft.class_2540;

public class SoulPulseEffectPacket extends SimplePacketBase {

	public class_2338 pos;
	public int distance;
	public boolean canOverlap;

	public SoulPulseEffectPacket(class_2338 pos, int distance, boolean overlaps) {
		this.pos = pos;
		this.distance = distance;
		this.canOverlap = overlaps;
	}

	public SoulPulseEffectPacket(class_2540 buffer) {
		pos = buffer.method_10811();
		distance = buffer.readInt();
		canOverlap = buffer.readBoolean();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(pos);
		buffer.writeInt(distance);
		buffer.writeBoolean(canOverlap);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			CreateClient.SOUL_PULSE_EFFECT_HANDLER.addPulse(new SoulPulseEffect(pos, distance, canOverlap));
		});
		return true;
	}

}
