package com.simibubi.create.content.equipment.blueprint;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_3222;

public class BlueprintAssignCompleteRecipePacket extends SimplePacketBase {

	private class_2960 recipeID;

	public BlueprintAssignCompleteRecipePacket(class_2960 recipeID) {
		this.recipeID = recipeID;
	}

	public BlueprintAssignCompleteRecipePacket(class_2540 buffer) {
		recipeID = buffer.method_10810();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10812(recipeID);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			if (player.field_7512 instanceof BlueprintMenu) {
				BlueprintMenu c = (BlueprintMenu) player.field_7512;
				player.method_37908()
						.method_8433()
						.method_8130(recipeID)
						.ifPresent(r -> BlueprintItem.assignCompleteRecipe(c.player.method_37908(), c.ghostInventory, r));
			}
		});
		return true;
	}

}
