package com.simibubi.create.content.equipment.goggles;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1304;
import net.minecraft.class_1308;
import net.minecraft.class_1657;
import net.minecraft.class_1738;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2315;
import com.simibubi.create.AllItems;

public class GogglesItem extends class_1792 {

	private static final List<Predicate<class_1657>> IS_WEARING_PREDICATES = new ArrayList<>();
	static {
		addIsWearingPredicate(player -> AllItems.GOGGLES.isIn(player.method_6118(class_1304.field_6169)));
	}

	public GogglesItem(class_1793 properties) {
		super(properties);
		class_2315.method_10009(this, class_1738.field_7879);
	}

	// Set in properties
	public static class_1304 getEquipmentSlot(class_1799 stack) {
		return class_1304.field_6169;
	}

	public class_1271<class_1799> method_7836(class_1937 worldIn, class_1657 playerIn, class_1268 handIn) {
		class_1799 itemstack = playerIn.method_5998(handIn);
		class_1304 equipmentslottype = class_1308.method_32326(itemstack);
		class_1799 itemstack1 = playerIn.method_6118(equipmentslottype);
		if (itemstack1.method_7960()) {
			playerIn.method_5673(equipmentslottype, itemstack.method_7972());
			itemstack.method_7939(0);
			return new class_1271<>(class_1269.field_5812, itemstack);
		} else {
			return new class_1271<>(class_1269.field_5814, itemstack);
		}
	}

	public static boolean isWearingGoggles(class_1657 player) {
		for (Predicate<class_1657> predicate : IS_WEARING_PREDICATES) {
			if (predicate.test(player)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Use this method to add custom entry points to the goggles overlay, e.g. custom
	 * armor, handheld alternatives, etc.
	 */
	public static void addIsWearingPredicate(Predicate<class_1657> predicate) {
		IS_WEARING_PREDICATES.add(predicate);
	}

}
