package com.simibubi.create.content.equipment.symmetryWand;

import java.util.ArrayList;
import java.util.List;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_310;


public class SymmetryEffectPacket extends SimplePacketBase {

	private class_2338 mirror;
	private List<class_2338> positions;

	public SymmetryEffectPacket(class_2338 mirror, List<class_2338> positions) {
		this.mirror = mirror;
		this.positions = positions;
	}

	public SymmetryEffectPacket(class_2540 buffer) {
		mirror = buffer.method_10811();
		int amt = buffer.readInt();
		positions = new ArrayList<>(amt);
		for (int i = 0; i < amt; i++) {
			positions.add(buffer.method_10811());
		}
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(mirror);
		buffer.writeInt(positions.size());
		for (class_2338 blockPos : positions) {
			buffer.method_10807(blockPos);
		}
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> {
			if (class_310.method_1551().field_1724.method_19538().method_1022(class_243.method_24954(mirror)) > 100)
				return;
			for (class_2338 to : positions)
				SymmetryHandler.drawEffect(mirror, to);
		}));
		return true;
	}

}
