package com.simibubi.create.content.equipment.zapper;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public abstract class ConfigureZapperPacket extends SimplePacketBase {

	protected class_1268 hand;
	protected PlacementPatterns pattern;

	public ConfigureZapperPacket(class_1268 hand, PlacementPatterns pattern) {
		this.hand = hand;
		this.pattern = pattern;
	}

	public ConfigureZapperPacket(class_2540 buffer) {
		hand = buffer.method_10818(class_1268.class);
		pattern = buffer.method_10818(PlacementPatterns.class);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10817(hand);
		buffer.method_10817(pattern);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null) {
				return;
			}
			class_1799 stack = player.method_5998(hand);
			if (stack.method_7909() instanceof ZapperItem) {
				configureZapper(stack);
			}
		});
		return true;
	}

	public abstract void configureZapper(class_1799 stack);

}
