package com.simibubi.create.content.equipment.zapper;

import com.simibubi.create.CreateClient;
import com.simibubi.create.content.equipment.zapper.ZapperRenderHandler.LaserBeam;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_243;
import net.minecraft.class_2540;

public class ZapperBeamPacket extends ShootGadgetPacket {

	public class_243 target;

	public ZapperBeamPacket(class_243 start, class_243 target, class_1268 hand, boolean self) {
		super(start, hand, self);
		this.target = target;
	}

	public ZapperBeamPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void readAdditional(class_2540 buffer) {
		target = new class_243(buffer.readDouble(), buffer.readDouble(), buffer.readDouble());
	}

	@Override
	protected void writeAdditional(class_2540 buffer) {
		buffer.writeDouble(target.field_1352);
		buffer.writeDouble(target.field_1351);
		buffer.writeDouble(target.field_1350);
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected ShootableGadgetRenderHandler getHandler() {
		return CreateClient.ZAPPER_RENDER_HANDLER;
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected void handleAdditional() {
		CreateClient.ZAPPER_RENDER_HANDLER.addBeam(new LaserBeam(location, target));
	}

}
