package com.simibubi.create.content.equipment.zapper;

import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModel;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModelRenderer;
import com.simibubi.create.foundation.item.render.PartialItemModelRenderer;
import net.minecraft.class_1087;
import net.minecraft.class_1799;
import net.minecraft.class_2310;
import net.minecraft.class_2512;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_7923;
import net.minecraft.class_811;

public abstract class ZapperItemRenderer extends CustomRenderedItemModelRenderer {

	@Override
	protected void render(class_1799 stack, CustomRenderedItemModel model, PartialItemModelRenderer renderer, class_811 transformType,
		class_4587 ms, class_4597 buffer, int light, int overlay) {
		// Block indicator
		if (transformType == class_811.field_4317 && stack.method_7985() && stack.method_7969()
			.method_10545("BlockUsed"))
			renderBlockUsed(stack, ms, buffer, light, overlay);
	}

	@SuppressWarnings("deprecation")
	private void renderBlockUsed(class_1799 stack, class_4587 ms, class_4597 buffer, int light, int overlay) {
		class_2680 state = class_2512.method_10681(class_7923.field_41175.method_46771(), stack.method_7969()
			.method_10562("BlockUsed"));

		ms.method_22903();
		ms.method_46416(-0.3F, -0.45F, -0.0F);
		ms.method_22905(0.25F, 0.25F, 0.25F);
		class_1087 modelForState = class_310.method_1551()
			.method_1541()
			.method_3349(state);

		if (state.method_26204() instanceof class_2310)
			modelForState = class_310.method_1551()
				.method_1480()
				.method_4019(new class_1799(state.method_26204()), null, null, 0);

		class_310.method_1551()
			.method_1480()
			.method_23179(new class_1799(state.method_26204()), class_811.field_4315, false, ms, buffer, light, overlay,
				modelForState);
		ms.method_22909();
	}

	protected float getAnimationProgress(float pt, boolean leftHanded, boolean mainHand) {
		float animation = CreateClient.ZAPPER_RENDER_HANDLER.getAnimation(mainHand ^ leftHanded, pt);
		return class_3532.method_15363(animation * 5, 0, 1);
	}

}
