package com.simibubi.create.content.equipment.zapper.terrainzapper;

import com.simibubi.create.content.equipment.zapper.ConfigureZapperPacket;
import com.simibubi.create.content.equipment.zapper.PlacementPatterns;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2540;

public class ConfigureWorldshaperPacket extends ConfigureZapperPacket {

	protected TerrainBrushes brush;
	protected int brushParamX;
	protected int brushParamY;
	protected int brushParamZ;
	protected TerrainTools tool;
	protected PlacementOptions placement;

	public ConfigureWorldshaperPacket(class_1268 hand, PlacementPatterns pattern, TerrainBrushes brush, int brushParamX, int brushParamY, int brushParamZ, TerrainTools tool, PlacementOptions placement) {
		super(hand, pattern);
		this.brush = brush;
		this.brushParamX = brushParamX;
		this.brushParamY = brushParamY;
		this.brushParamZ = brushParamZ;
		this.tool = tool;
		this.placement = placement;
	}

	public ConfigureWorldshaperPacket(class_2540 buffer) {
		super(buffer);
		brush = buffer.method_10818(TerrainBrushes.class);
		brushParamX = buffer.method_10816();
		brushParamY = buffer.method_10816();
		brushParamZ = buffer.method_10816();
		tool = buffer.method_10818(TerrainTools.class);
		placement = buffer.method_10818(PlacementOptions.class);
	}

	@Override
	public void write(class_2540 buffer) {
		super.write(buffer);
		buffer.method_10817(brush);
		buffer.method_10804(brushParamX);
		buffer.method_10804(brushParamY);
		buffer.method_10804(brushParamZ);
		buffer.method_10817(tool);
		buffer.method_10817(placement);
	}

	@Override
	public void configureZapper(class_1799 stack) {
		WorldshaperItem.configureSettings(stack, pattern, brush, brushParamX, brushParamY, brushParamZ, tool, placement);
	}

}
