package com.simibubi.create.content.fluids.pipes;

import com.simibubi.create.foundation.data.AssetLookup;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2738;

public class SmartFluidPipeGenerator extends SpecialBlockStateGen {

	@Override
	protected int getXRotation(class_2680 state) {
		class_2738 attachFace = state.method_11654(SmartFluidPipeBlock.field_11007);
		return attachFace == class_2738.field_12473 ? 180 : attachFace == class_2738.field_12475 ? 0 : 270;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		class_2738 attachFace = state.method_11654(SmartFluidPipeBlock.field_11007);
		int angle = horizontalAngle(state.method_11654(SmartFluidPipeBlock.field_11177));
		return angle + (attachFace == class_2738.field_12473 ? 180 : 0);
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		return AssetLookup.partialBaseModel(ctx, prov);
	}

}
