package com.simibubi.create.content.fluids.pump;

import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.api.instance.DynamicInstance;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.SingleRotatingInstance;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_2741;

public class PumpCogInstance extends SingleRotatingInstance<PumpBlockEntity> implements DynamicInstance {

	public PumpCogInstance(MaterialManager materialManager, PumpBlockEntity blockEntity) {
		super(materialManager, blockEntity);
	}
	
	@Override
	public void beginFrame() {}

	@Override
	protected Instancer<RotatingData> getModel() {
		class_2680 referenceState = blockEntity.method_11010();
		class_2350 facing = referenceState.method_11654(class_2741.field_12525);
		return getRotatingMaterial().getModel(AllPartialModels.MECHANICAL_PUMP_COG, referenceState, facing);
	}

}
