package com.simibubi.create.content.fluids.transfer;

import com.simibubi.create.content.fluids.FluidFX;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_310;


public class FluidSplashPacket extends SimplePacketBase {

	private class_2338 pos;
	private FluidStack fluid;

	public FluidSplashPacket(class_2338 pos, FluidStack fluid) {
		this.pos = pos;
		this.fluid = fluid;
	}

	public FluidSplashPacket(class_2540 buffer) {
		pos = buffer.method_10811();
		fluid =FluidStack.readFromPacket(buffer);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(pos);
		fluid.writeToPacket(buffer);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> {
			if (class_310.method_1551().field_1724.method_19538()
				.method_1022(new class_243(pos.method_10263(), pos.method_10264(), pos.method_10260())) > 100)
				return;
			FluidFX.splash(pos, fluid);
		}));
		return true;
	}

}
