package com.simibubi.create.content.kinetics.base.flwdata;

import net.minecraft.class_2350;
import org.joml.Vector3f;

public class RotatingData extends KineticData {
    byte rotationAxisX;
    byte rotationAxisY;
    byte rotationAxisZ;

    public RotatingData setRotationAxis(class_2350.class_2351 axis) {
        class_2350 orientation = class_2350.method_10156(class_2350.class_2352.field_11056, axis);
        return setRotationAxis(orientation.method_23955());
    }

    public RotatingData setRotationAxis(Vector3f axis) {
        return setRotationAxis(axis.x(), axis.y(), axis.z());
	}

	public RotatingData setRotationAxis(float rotationAxisX, float rotationAxisY, float rotationAxisZ) {
		this.rotationAxisX = (byte) (rotationAxisX * 127);
		this.rotationAxisY = (byte) (rotationAxisY * 127);
		this.rotationAxisZ = (byte) (rotationAxisZ * 127);
		markDirty();
		return this;
	}

}
