package com.simibubi.create.content.kinetics.belt.item;

import java.util.LinkedList;
import java.util.List;
import net.minecraft.class_1268;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_239;
import net.minecraft.class_2390;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2741;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_5819;
import org.joml.Vector3f;

import com.simibubi.create.AllItems;
import com.simibubi.create.content.kinetics.simpleRelays.ShaftBlock;
import com.simibubi.create.infrastructure.config.AllConfigs;

public class BeltConnectorHandler {

	private static class_5819 r = class_5819.method_43047();

	public static void tick() {
		class_1657 player = class_310.method_1551().field_1724;
		class_1937 world = class_310.method_1551().field_1687;

		if (player == null || world == null)
			return;
		if (class_310.method_1551().field_1755 != null)
			return;

		for (class_1268 hand : class_1268.values()) {
			class_1799 heldItem = player.method_5998(hand);

			if (!AllItems.BELT_CONNECTOR.isIn(heldItem))
				continue;
			if (!heldItem.method_7985())
				continue;

			class_2487 tag = heldItem.method_7969();
			if (!tag.method_10545("FirstPulley"))
				continue;

			class_2338 first = class_2512.method_10691(tag.method_10562("FirstPulley"));

			if (!world.method_8320(first)
				.method_28498(class_2741.field_12496))
				continue;
			class_2351 axis = world.method_8320(first)
				.method_11654(class_2741.field_12496);

			class_239 rayTrace = class_310.method_1551().field_1765;
			if (rayTrace == null || !(rayTrace instanceof class_3965)) {
				if (r.method_43048(50) == 0) {
					world.method_8406(new class_2390(new Vector3f(.3f, .9f, .5f), 1),
						first.method_10263() + .5f + randomOffset(.25f), first.method_10264() + .5f + randomOffset(.25f),
						first.method_10260() + .5f + randomOffset(.25f), 0, 0, 0);
				}
				return;
			}

			class_2338 selected = ((class_3965) rayTrace).method_17777();

			if (world.method_8320(selected)
				.method_45474())
				return;
			if (!ShaftBlock.isShaft(world.method_8320(selected)))
				selected = selected.method_10093(((class_3965) rayTrace).method_17780());
			if (!selected.method_19771(first, AllConfigs.server().kinetics.maxBeltLength.get()))
				return;

			boolean canConnect =
				BeltConnectorItem.validateAxis(world, selected) && BeltConnectorItem.canConnect(world, first, selected);

			class_243 start = class_243.method_24954(first);
			class_243 end = class_243.method_24954(selected);
			class_243 actualDiff = end.method_1020(start);
			end = end.method_1023(axis.method_10172(actualDiff.field_1352, 0, 0), axis.method_10172(0, actualDiff.field_1351, 0),
				axis.method_10172(0, 0, actualDiff.field_1350));
			class_243 diff = end.method_1020(start);

			double x = Math.abs(diff.field_1352);
			double y = Math.abs(diff.field_1351);
			double z = Math.abs(diff.field_1350);
			float length = (float) Math.max(x, Math.max(y, z));
			class_243 step = diff.method_1029();

			int sames = ((x == y) ? 1 : 0) + ((y == z) ? 1 : 0) + ((z == x) ? 1 : 0);
			if (sames == 0) {
				List<class_243> validDiffs = new LinkedList<>();
				for (int i = -1; i <= 1; i++)
					for (int j = -1; j <= 1; j++)
						for (int k = -1; k <= 1; k++) {
							if (axis.method_10173(i, j, k) != 0)
								continue;
							if (axis == class_2351.field_11052 && i != 0 && k != 0)
								continue;
							if (i == 0 && j == 0 && k == 0)
								continue;
							validDiffs.add(new class_243(i, j, k));
						}
				int closestIndex = 0;
				float closest = Float.MAX_VALUE;
				for (class_243 validDiff : validDiffs) {
					double distanceTo = step.method_1022(validDiff);
					if (distanceTo < closest) {
						closest = (float) distanceTo;
						closestIndex = validDiffs.indexOf(validDiff);
					}
				}
				step = validDiffs.get(closestIndex);
			}

			if (axis == class_2351.field_11052 && step.field_1352 != 0 && step.field_1350 != 0)
				return;

			step = new class_243(Math.signum(step.field_1352), Math.signum(step.field_1351), Math.signum(step.field_1350));
			for (float f = 0; f < length; f += .0625f) {
				class_243 position = start.method_1019(step.method_1021(f));
				if (r.method_43048(10) == 0) {
					world.method_8406(
						new class_2390(new Vector3f(canConnect ? .3f : .9f, canConnect ? .9f : .3f, .5f), 1),
						position.field_1352 + .5f, position.field_1351 + .5f, position.field_1350 + .5f, 0, 0, 0);
				}
			}

			return;
		}
	}

	private static float randomOffset(float range) {
		return (r.method_43057() - .5f) * 2 * range;
	}

}
