package com.simibubi.create.content.kinetics.crafter;

import java.util.function.Supplier;
import net.minecraft.class_2350;
import net.minecraft.class_4587;
import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.base.SingleRotatingInstance;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;

public class ShaftlessCogwheelInstance extends SingleRotatingInstance<KineticBlockEntity> {

    public ShaftlessCogwheelInstance(MaterialManager materialManager, KineticBlockEntity blockEntity) {
        super(materialManager, blockEntity);
    }

    @Override
    protected Instancer<RotatingData> getModel() {
        class_2350 facing = blockState.method_11654(MechanicalCrafterBlock.HORIZONTAL_FACING);

		return getRotatingMaterial().getModel(AllPartialModels.SHAFTLESS_COGWHEEL, blockState, facing, rotateToFace(facing));
    }

	private Supplier<class_4587> rotateToFace(class_2350 facing) {
		return () -> {
			class_4587 stack = new class_4587();
			TransformStack stacker = TransformStack.cast(stack)
					.centre();

			if (facing.method_10166() == class_2350.class_2351.field_11048) stacker.rotateZ(90);
			else if (facing.method_10166() == class_2350.class_2351.field_11051) stacker.rotateX(90);

			stacker.unCentre();
			return stack;
		};
	}
}
