package com.simibubi.create.content.kinetics.gauge;

import java.util.List;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import com.simibubi.create.content.equipment.goggles.IHaveGoggleInformation;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.foundation.utility.Lang;

public abstract class GaugeBlockEntity extends KineticBlockEntity implements IHaveGoggleInformation {

	public float dialTarget;
	public float dialState;
	public float prevDialState;
	public int color;

	public GaugeBlockEntity(class_2591<?> typeIn, class_2338 pos, class_2680 state) {
		super(typeIn, pos, state);
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		compound.method_10548("Value", dialTarget);
		compound.method_10569("Color", color);
		super.write(compound, clientPacket);
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		dialTarget = compound.method_10583("Value");
		color = compound.method_10550("Color");
		super.read(compound, clientPacket);
	}

	@Override
	public void tick() {
		super.tick();
		prevDialState = dialState;
		dialState += (dialTarget - dialState) * .125f;
		if (dialState > 1 && field_11863.field_9229.method_43057() < 1 / 2f)
			dialState -= (dialState - 1) * field_11863.field_9229.method_43057();
	}

	@Override
	public boolean addToGoggleTooltip(List<class_2561> tooltip, boolean isPlayerSneaking) {
		tooltip.add(componentSpacing.method_27662().method_10852(Lang.translateDirect("gui.gauge.info_header")));

		return true;
	}

}
