package com.simibubi.create.content.kinetics.gearbox;

import java.util.Arrays;
import java.util.List;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.kinetics.base.RotatedPillarKineticBlock;
import com.simibubi.create.foundation.block.IBE;

import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_239;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_4538;
import net.minecraft.class_8567;

public class GearboxBlock extends RotatedPillarKineticBlock implements IBE<GearboxBlockEntity>, BlockPickInteractionAware {

	public GearboxBlock(class_2251 properties) {
		super(properties);
	}

	@SuppressWarnings("deprecation")
	@Override
	public List<class_1799> method_9560(class_2680 state, class_8567.class_8568 builder) {
		if (state.method_11654(AXIS).method_10178())
			return super.method_9560(state, builder);
		return Arrays.asList(new class_1799(AllItems.VERTICAL_GEARBOX.get()));
	}

	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 view, class_2338 pos, @Nullable class_1657 player, @Nullable class_239 result) {
		if (state.method_11654(AXIS).method_10178())
			return super.method_9574(view, pos, state);
		return new class_1799(AllItems.VERTICAL_GEARBOX.get());
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		return method_9564().method_11657(AXIS, class_2351.field_11052);
	}

	// IRotate:

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face.method_10166() != state.method_11654(AXIS);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(AXIS);
	}

	@Override
	public Class<GearboxBlockEntity> getBlockEntityClass() {
		return GearboxBlockEntity.class;
	}

	@Override
	public class_2591<? extends GearboxBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.GEARBOX.get();
	}
}
