package com.simibubi.create.content.kinetics.saw;

import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_2680;

public class SawGenerator extends SpecialBlockStateGen {

	@Override
	protected int getXRotation(class_2680 state) {
		return state.method_11654(SawBlock.FACING) == class_2350.field_11033 ? 180 : 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		class_2350 facing = state.method_11654(SawBlock.FACING);
		boolean axisAlongFirst = state.method_11654(SawBlock.AXIS_ALONG_FIRST_COORDINATE);
		if (facing.method_10166()
			.method_10178())
			return (axisAlongFirst ? 270 : 0) + (state.method_11654(SawBlock.FLIPPED) ? 180 : 0);
		return horizontalAngle(facing);
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		String path = "block/" + ctx.getName() + "/";
		String orientation = state.method_11654(SawBlock.FACING)
			.method_10166()
			.method_10178() ? "vertical" : "horizontal";

		return prov.models()
			.getExistingFile(prov.modLoc(path + orientation));
	}

}
