package com.simibubi.create.content.kinetics.transmission.sequencer;

import com.simibubi.create.foundation.networking.BlockEntityConfigurationPacket;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2540;

public class ConfigureSequencedGearshiftPacket extends BlockEntityConfigurationPacket<SequencedGearshiftBlockEntity> {

	private class_2499 instructions;

	public ConfigureSequencedGearshiftPacket(class_2338 pos, class_2499 instructions) {
		super(pos);
		this.instructions = instructions;
	}

	public ConfigureSequencedGearshiftPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void readSettings(class_2540 buffer) {
		instructions = buffer.method_10798().method_10554("data", class_2520.field_33260);
	}

	@Override
	protected void writeSettings(class_2540 buffer) {
		class_2487 tag = new class_2487();
		tag.method_10566("data", instructions);
		buffer.method_10794(tag);
	}

	@Override
	protected void applySettings(SequencedGearshiftBlockEntity be) {
		if (be.computerBehaviour.hasAttachedComputer())
			return;

		be.run(-1);
		be.instructions = Instruction.deserializeAll(instructions);
		be.sendData();
	}

}
