package com.simibubi.create.content.kinetics.turntable;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_310;
import net.minecraft.class_3532;

public class TurntableHandler {

	public static void gameRenderTick() {
		class_310 mc = class_310.method_1551();
		class_2338 pos = mc.field_1724.method_24515();

		if (mc.field_1761 == null)
			return;
		if (!AllBlocks.TURNTABLE.has(mc.field_1687.method_8320(pos)))
			return;
		if (!mc.field_1724.method_24828())
			return;
		if (mc.method_1493())
			return;

		class_2586 blockEntity = mc.field_1687.method_8321(pos);
		if (!(blockEntity instanceof TurntableBlockEntity))
			return;
		
		TurntableBlockEntity turnTable = (TurntableBlockEntity) blockEntity;
		float speed = turnTable.getSpeed() * 3/10;

		if (speed == 0)
			return;
		
		class_243 origin = VecHelper.getCenterOf(pos);
		class_243 offset = mc.field_1724.method_19538().method_1020(origin);
		
		if (offset.method_1033() > 1/4f)
			speed *= class_3532.method_15350((1/2f - offset.method_1033()) * 2, 0, 1);

		mc.field_1724.method_36456(mc.field_1724.field_5982 - speed * AnimationTickHolder.getPartialTicks());
		mc.field_1724.field_6283 = mc.field_1724.method_36454();
	}

}
