package com.simibubi.create.content.kinetics.waterwheel;

import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;

import io.github.fabricators_of_create.porting_lib.util.EnvExecutor;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1269;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_746;

public class LargeWaterWheelBlockItem extends class_1747 {

	public LargeWaterWheelBlockItem(class_2248 pBlock, class_1793 pProperties) {
		super(pBlock, pProperties);
	}

	@Override
	public class_1269 method_7712(class_1750 ctx) {
		class_1269 result = super.method_7712(ctx);
		if (result != class_1269.field_5814)
			return result;
		class_2350 clickedFace = ctx.method_8038();
		if (clickedFace.method_10166() != ((LargeWaterWheelBlock) method_7711()).getAxisForPlacement(ctx))
			result = super.method_7712(class_1750.method_16355(ctx, ctx.method_8037()
				.method_10093(clickedFace), clickedFace));
		if (result == class_1269.field_5814 && ctx.method_8045()
			.method_8608())
			EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> showBounds(ctx));
		return result;
	}

	@Environment(EnvType.CLIENT)
	public void showBounds(class_1750 context) {
		class_2338 pos = context.method_8037();
		class_2351 axis = ((LargeWaterWheelBlock) method_7711()).getAxisForPlacement(context);
		class_243 contract = class_243.method_24954(class_2350.method_10156(class_2352.field_11056, axis)
			.method_10163());
		if (!(context.method_8036()instanceof class_746 localPlayer))
			return;
		CreateClient.OUTLINER.showAABB(Pair.of("waterwheel", pos), new class_238(pos).method_1014(1)
			.method_35580(contract.field_1352, contract.field_1351, contract.field_1350))
			.colored(0xFF_ff5d6c);
		Lang.translate("large_water_wheel.not_enough_space")
			.color(0xFF_ff5d6c)
			.sendStatus(localPlayer);
	}

}
