package com.simibubi.create.content.logistics.chute;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.content.logistics.chute.ChuteBlock.Shape;
import com.simibubi.create.foundation.blockEntity.renderer.SafeBlockEntityRenderer;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_811;
import net.minecraft.class_918;

public class ChuteRenderer extends SafeBlockEntityRenderer<ChuteBlockEntity> {

	public ChuteRenderer(class_5614.class_5615 context) {}

	@Override
	protected void renderSafe(ChuteBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer, int light,
		int overlay) {
		if (be.item.method_7960())
			return;
		class_2680 blockState = be.method_11010();
		if (blockState.method_11654(ChuteBlock.FACING) != class_2350.field_11033)
			return;
		if (blockState.method_11654(ChuteBlock.SHAPE) != Shape.WINDOW
			&& (be.bottomPullDistance == 0 || be.itemPosition.getValue(partialTicks) > .5f))
			return;

		renderItem(be, partialTicks, ms, buffer, light, overlay);
	}

	public static void renderItem(ChuteBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		class_918 itemRenderer = class_310.method_1551()
			.method_1480();
		TransformStack msr = TransformStack.cast(ms);
		ms.method_22903();
		msr.centre();
		float itemScale = .5f;
		float itemPosition = be.itemPosition.getValue(partialTicks);
		ms.method_22904(0, -.5 + itemPosition, 0);
		ms.method_22905(itemScale, itemScale, itemScale);
		msr.rotateX(itemPosition * 180);
		msr.rotateY(itemPosition * 180);
		itemRenderer.method_23178(be.item, class_811.field_4319, light, overlay, ms, buffer, be.method_10997(), 0);
		ms.method_22909();
	}

}
