package com.simibubi.create.content.materials;

import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_1268;
import net.minecraft.class_1271;
import net.minecraft.class_1303;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3532;

public class ExperienceNuggetItem extends class_1792 {

	public ExperienceNuggetItem(class_1793 pProperties) {
		super(pProperties);
	}

	@Override
	public boolean method_7886(class_1799 pStack) {
		return true;
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 pLevel, class_1657 pPlayer, class_1268 pUsedHand) {
		class_1799 itemInHand = pPlayer.method_5998(pUsedHand);
		if (pLevel.field_9236) {
			pLevel.method_8396(pPlayer, pPlayer.method_24515(), class_3417.field_26979, class_3419.field_15248,
				.5f, 1);
			return class_1271.method_22428(itemInHand);
		}

		int amountUsed = pPlayer.method_5715() ? 1 : itemInHand.method_7947();
		int total = class_3532.method_15386(3f * amountUsed);
		int maxOrbs = amountUsed == 1 ? 1 : 5;
		int valuePer = Math.max(1, 1 + total / maxOrbs);

		for (int i = 0; i < maxOrbs; i++) {
			int value = Math.min(valuePer, total - i * valuePer);
			if (value == 0)
				continue;

			class_243 offset = VecHelper.offsetRandomly(class_243.field_1353, pLevel.field_9229, 1)
				.method_1029();
			class_243 look = pPlayer.method_5720();
			class_243 motion = look.method_1021(0.2)
				.method_1031(0, 0.2, 0)
				.method_1019(offset.method_1021(.1));
			class_243 cross = look.method_1036(VecHelper.rotate(new class_243(-.75f, 0, 0), -pPlayer.method_36454(), class_2351.field_11052));

			class_243 global = pPlayer.method_33571()
				.method_1019(look.method_1021(.5f))
				.method_1019(cross);
			class_1303 xp = new class_1303(pLevel, global.field_1352, global.field_1351, global.field_1350, value);
			xp.method_18799(motion);
			pLevel.method_8649(xp);
		}

		itemInHand.method_7934(amountUsed);
		if (!itemInHand.method_7960())
			return class_1271.method_22427(itemInHand);

		pPlayer.method_6122(pUsedHand, class_1799.field_8037);
		return class_1271.method_22428(itemInHand);
	}

}
