package com.simibubi.create.content.processing.basin;

import java.util.HashMap;
import java.util.Map;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import com.simibubi.create.content.contraptions.behaviour.MovementBehaviour;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;

public class BasinMovementBehaviour implements MovementBehaviour {
	public Map<String, ItemStackHandler> getOrReadInventory(MovementContext context) {
		Map<String, ItemStackHandler> map = new HashMap<>();
		map.put("InputItems", new ItemStackHandler(9));
		map.put("OutputItems", new ItemStackHandler(8));
		map.forEach((s, h) -> h.deserializeNBT(context.blockEntityData.method_10562(s)));
		return map;
	}

	@Override
	public boolean renderAsNormalBlockEntity() {
		return true;
	}

	@Override
	public void tick(MovementContext context) {
		MovementBehaviour.super.tick(context);
		if (context.temporaryData == null || (boolean) context.temporaryData) {
			class_243 facingVec = context.rotation.apply(class_243.method_24954(class_2350.field_11036.method_10163()));
			facingVec.method_1029();
			if (class_2350.method_10142(facingVec.field_1352, facingVec.field_1351, facingVec.field_1350) == class_2350.field_11033)
				dump(context, facingVec);
		}
	}

	private void dump(MovementContext context, class_243 facingVec) {
		getOrReadInventory(context).forEach((key, itemStackHandler) -> {
			for (int i = 0; i < itemStackHandler.getSlotCount(); i++) {
				if (itemStackHandler.getStackInSlot(i)
					.method_7960())
					continue;
				class_1542 itemEntity = new class_1542(context.world, context.position.field_1352, context.position.field_1351,
					context.position.field_1350, itemStackHandler.getStackInSlot(i));
				itemEntity.method_18799(facingVec.method_1021(.05));
				context.world.method_8649(itemEntity);
				itemStackHandler.setStackInSlot(i, class_1799.field_8037);
			}
			context.blockEntityData.method_10566(key, itemStackHandler.serializeNBT());
		});
		class_2586 blockEntity = context.contraption.presentBlockEntities.get(context.localPos);
		if (blockEntity instanceof BasinBlockEntity)
			((BasinBlockEntity) blockEntity).readOnlyItems(context.blockEntityData);
		context.temporaryData = false; // did already dump, so can't any more
	}
}
