package com.simibubi.create.content.redstone.contact;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.contraptions.elevator.ElevatorColumn;
import com.simibubi.create.content.contraptions.elevator.ElevatorColumn.ColumnCoords;
import com.simibubi.create.foundation.utility.BlockHelper;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;

public class RedstoneContactItem extends class_1747 {

	public RedstoneContactItem(class_2248 pBlock, class_1793 pProperties) {
		super(pBlock, pProperties);
	}

	@Override
	protected class_2680 method_7707(class_1750 ctx) {
		class_1937 world = ctx.method_8045();
		class_2338 pos = ctx.method_8037();
		class_2680 state = super.method_7707(ctx);

		if (state == null)
			return state;
		if (!(state.method_26204() instanceof RedstoneContactBlock))
			return state;
		class_2350 facing = state.method_11654(RedstoneContactBlock.field_10927);
		if (facing.method_10166() == class_2351.field_11052)
			return state;

		if (ElevatorColumn.get(world, new ColumnCoords(pos.method_10263(), pos.method_10260(), facing)) == null)
			return state;

		return BlockHelper.copyProperties(state, AllBlocks.ELEVATOR_CONTACT.getDefaultState());
	}

}
