package com.simibubi.create.content.redstone.diodes;

import java.util.Vector;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import com.tterrag.registrate.providers.DataGenContext;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.block.BlockModelProvider;

public class BrassDiodeGenerator extends AbstractDiodeGenerator {

	@Override
	protected <T extends class_2248> Vector<ModelFile> createModels(DataGenContext<class_2248, T> ctx, BlockModelProvider prov) {
		Vector<ModelFile> models = makeVector(4);
		String name = ctx.getName();
		class_2960 template = existing(name);

		models.add(prov.getExistingFile(template));
		models.add(prov.withExistingParent(name + "_powered", template)
			.texture("top", texture(ctx, "powered")));
		models.add(prov.withExistingParent(name + "_powering", template)
			.texture("torch", poweredTorch())
			.texture("top", texture(ctx, "powering")));
		models.add(prov.withExistingParent(name + "_powered_powering", template)
			.texture("torch", poweredTorch())
			.texture("top", texture(ctx, "powered_powering")));

		return models;
	}

	@Override
	protected int getModelIndex(class_2680 state) {
		return (state.method_11654(BrassDiodeBlock.POWERING) ^ state.method_11654(BrassDiodeBlock.INVERTED) ? 2 : 0)
			+ (state.method_11654(BrassDiodeBlock.field_10911) ? 1 : 0);
	}

}
