package com.simibubi.create.content.redstone.diodes;

import java.util.Vector;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import com.tterrag.registrate.providers.DataGenContext;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.block.BlockModelProvider;

public class PoweredLatchGenerator extends AbstractDiodeGenerator {

	@Override
	protected <T extends class_2248> Vector<ModelFile> createModels(DataGenContext<class_2248, T> ctx, BlockModelProvider prov) {
		Vector<ModelFile> models = makeVector(2);
		String name = ctx.getName();
		class_2960 off = existing("latch_off");
		class_2960 on = existing("latch_on");

		models.add(prov.withExistingParent(name, off)
			.texture("top", texture(ctx, "idle")));
		models.add(prov.withExistingParent(name + "_powered", on)
			.texture("top", texture(ctx, "powering")));

		return models;
	}

	@Override
	protected int getModelIndex(class_2680 state) {
		return state.method_11654(PoweredLatchBlock.POWERING) ? 1 : 0;
	}

}
