package com.simibubi.create.content.redstone.displayLink.source;

import java.util.List;
import net.minecraft.class_1297;
import net.minecraft.class_238;
import net.minecraft.class_5250;
import com.simibubi.create.content.contraptions.actors.seat.SeatEntity;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTargetStats;

public class EntityNameDisplaySource extends SingleLineDisplaySource {
	@Override
	protected class_5250 provideLine(DisplayLinkContext context, DisplayTargetStats stats) {
		List<SeatEntity> seats = context.level().method_18467(SeatEntity.class, new class_238(context.getSourcePos()));

		if (seats.isEmpty())
			return EMPTY_LINE;

		SeatEntity seatEntity = seats.get(0);
		List<class_1297> passengers = seatEntity.method_5685();

		if (passengers.isEmpty())
			return EMPTY_LINE;

		return passengers.get(0).method_5476().method_27661();
	}

	@Override
	protected String getTranslationKey() {
		return "entity_name";
	}

	@Override
	protected boolean allowsLabeling(DisplayLinkContext context) {
		return true;
	}
}
