package com.simibubi.create.content.redstone.displayLink.source;

import java.util.stream.Stream;

import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.gui.ModularGuiLineBuilder;
import com.simibubi.create.foundation.utility.LongAttached;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1937;
import net.minecraft.class_2561;
import net.minecraft.class_266;
import net.minecraft.class_269;
import net.minecraft.class_274;
import net.minecraft.class_274.class_275;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_5250;

public abstract class StatTrackingDisplaySource extends ScoreboardDisplaySource {

	@Override
	protected Stream<LongAttached<class_5250>> provideEntries(DisplayLinkContext context, int maxRows) {
		class_1937 level = context.blockEntity()
			.method_10997();
		if (!(level instanceof class_3218 sLevel))
			return Stream.empty();

		String name = "create_auto_" + getObjectiveName();
		class_269 scoreboard = level.method_8428();
		if (!scoreboard.method_1181(name))
			scoreboard.method_1168(name, class_274.field_1468, getObjectiveDisplayName(), class_275.field_1472);
		class_266 objective = scoreboard.method_1170(name);

		sLevel.method_8503().method_3760().method_14571()
			.forEach(s -> scoreboard.method_1180(s.method_5820(), objective)
				.method_1128(updatedScoreOf(s)));

		return showScoreboard(sLevel, name, maxRows);
	}

	protected abstract String getObjectiveName();

	protected abstract class_2561 getObjectiveDisplayName();

	protected abstract int updatedScoreOf(class_3222 player);

	@Override
	protected boolean valueFirst() {
		return false;
	}

	@Override
	protected boolean shortenNumbers(DisplayLinkContext context) {
		return false;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void initConfigurationWidgets(DisplayLinkContext context, ModularGuiLineBuilder builder, boolean isFirstLine) {}

}
