package com.simibubi.create.content.redstone.displayLink.target;

import java.util.List;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2586;
import net.minecraft.class_265;
import net.minecraft.class_5250;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.redstone.displayLink.DisplayBehaviour;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.utility.Lang;

public abstract class DisplayTarget extends DisplayBehaviour {

	public abstract void acceptText(int line, List<class_5250> text, DisplayLinkContext context);

	public abstract DisplayTargetStats provideStats(DisplayLinkContext context);

	public class_238 getMultiblockBounds(class_1936 level, class_2338 pos) {
		class_265 shape = level.method_8320(pos)
			.method_26218(level, pos);
		if (shape.method_1110())
			return new class_238(pos);
		return shape.method_1107()
			.method_996(pos);
	}

	public class_2561 getLineOptionText(int line) {
		return Lang.translateDirect("display_target.line", line + 1);
	}

	public static void reserve(int line, class_2586 target, DisplayLinkContext context) {
		if (line == 0)
			return;

		class_2487 tag = target.getCustomData();
		class_2487 compound = tag.method_10562("DisplayLink");
		compound.method_10544("Line" + line, context.blockEntity()
			.method_11016()
			.method_10063());
		tag.method_10566("DisplayLink", compound);
	}

	public boolean isReserved(int line, class_2586 target, DisplayLinkContext context) {
		class_2487 tag = target.getCustomData();
		class_2487 compound = tag.method_10562("DisplayLink");

		if (!compound.method_10545("Line" + line))
			return false;

		long l = compound.method_10537("Line" + line);
		class_2338 reserved = class_2338.method_10092(l);

		if (!reserved.equals(context.blockEntity()
			.method_11016()) && AllBlocks.DISPLAY_LINK.has(target.method_10997()
				.method_8320(reserved)))
			return true;

		compound.method_10551("Line" + line);
		if (compound.method_33133())
			tag.method_10551("DisplayLink");
		return false;
	}

}
