package com.simibubi.create.content.redstone.displayLink.target;

import java.util.List;
import net.minecraft.class_2561;
import net.minecraft.class_5250;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.utility.Lang;

public abstract class SingleLineDisplayTarget extends DisplayTarget {

	@Override
	public final void acceptText(int line, List<class_5250> text, DisplayLinkContext context) {
		acceptLine(text.get(0), context);
	}
	
	protected abstract void acceptLine(class_5250 text, DisplayLinkContext context);

	@Override
	public final DisplayTargetStats provideStats(DisplayLinkContext context) {
		return new DisplayTargetStats(1, getWidth(context), this);
	}
	
	@Override
	public class_2561 getLineOptionText(int line) {
		return Lang.translateDirect("display_target.single_line");
	}
	
	protected abstract int getWidth(DisplayLinkContext context);

}
