package com.simibubi.create.content.redstone.nixieTube;

import com.simibubi.create.content.redstone.nixieTube.DoubleFaceAttachedBlock.DoubleAttachFace;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2680;

public class NixieTubeGenerator extends SpecialBlockStateGen {

	@Override
	protected int getXRotation(class_2680 state) {
		return state.method_11654(NixieTubeBlock.FACE)
			.xRot();
	}

	@Override
	protected int getYRotation(class_2680 state) {
		DoubleAttachFace face = state.method_11654(NixieTubeBlock.FACE);
		return horizontalAngle(state.method_11654(NixieTubeBlock.field_11177))
			+ (face == DoubleAttachFace.WALL || face == DoubleAttachFace.WALL_REVERSED ? 180 : 0);
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		return prov.models()
			.withExistingParent(ctx.getName(), prov.modLoc("block/nixie_tube/block"));
	}

}
