package com.simibubi.create.content.schematics;

import java.util.Optional;

import javax.annotation.Nullable;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2343;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_3491;
import net.minecraft.class_3492;
import net.minecraft.class_3499;
import net.minecraft.class_3828;
import net.minecraft.class_4538;
import com.mojang.serialization.Codec;
import com.simibubi.create.AllStructureProcessorTypes;
import com.simibubi.create.foundation.utility.NBTProcessors;

import io.github.fabricators_of_create.porting_lib.extensions.extensions.StructureProcessorExtensions;

public class SchematicProcessor extends class_3491 implements StructureProcessorExtensions {
	public static final SchematicProcessor INSTANCE = new SchematicProcessor();
	public static final Codec<SchematicProcessor> CODEC = Codec.unit(() -> {
		return INSTANCE;
	});


	@Nullable
	@Override
	public class_3499.class_3501 method_15110(class_4538 world, class_2338 pos, class_2338 anotherPos, class_3499.class_3501 rawInfo,
			class_3499.class_3501 info, class_3492 settings) {
		if (info.comp_1343() != null && info.comp_1342().method_31709()) {
			class_2586 be = ((class_2343) info.comp_1342().method_26204()).method_10123(info.comp_1341(), info.comp_1342());
			if (be != null) {
				class_2487 nbt = NBTProcessors.process(be, info.comp_1343(), false);
				if (nbt != info.comp_1343())
					return new class_3499.class_3501(info.comp_1341(), info.comp_1342(), nbt);
			}
		}
		return info;
	}

	@Nullable
	@Override
	public class_3499.class_3502 processEntity(class_4538 world, class_2338 pos, class_3499.class_3502 rawInfo,
			class_3499.class_3502 info, class_3492 settings, class_3499 template) {
		return class_1299.method_17684(info.field_15598).flatMap(type -> {
			if (world instanceof class_1937) {
				class_1297 e = type.method_5883((class_1937) world);
				if (e != null && !e.method_5833()) {
					return Optional.of(info);
				}
			}
			return Optional.empty();
		}).orElse(null);
	}

	@Override
	protected class_3828<?> method_16772() {
		return AllStructureProcessorTypes.SCHEMATIC.get();
	}

}
