package com.simibubi.create.content.schematics.client.tools;

import com.simibubi.create.content.schematics.client.SchematicTransformation;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;

public class MoveTool extends PlacementToolBase {

	@Override
	public void init() {
		super.init();
		renderSelectedFace = true;
	}

	@Override
	public void updateSelection() {
		super.updateSelection();
	}

	@Override
	public boolean handleMouseWheel(double delta) {
		if (!schematicSelected || !selectedFace.method_10166().method_10179())
			return true;

		SchematicTransformation transformation = schematicHandler.getTransformation();
		class_243 vec = class_243.method_24954(selectedFace.method_10163()).method_1021(-Math.signum(delta));
		vec = vec.method_18805(transformation.getMirrorModifier(class_2351.field_11048), 1, transformation.getMirrorModifier(class_2351.field_11051));
		vec = VecHelper.rotate(vec, transformation.getRotationTarget(), class_2351.field_11052);
		transformation.move((int) vec.field_1352, 0, (int) vec.field_1350);
		schematicHandler.markDirty();
		
		return true;
	}

}
