package com.simibubi.create.content.trains.entity;

import com.simibubi.create.content.trains.TrainHUD;
import com.simibubi.create.foundation.networking.SimplePacketBase;

import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2540;
import net.minecraft.class_2561;

public class TrainPromptPacket extends SimplePacketBase {

	private class_2561 text;
	private boolean shadow;

	public TrainPromptPacket(class_2561 text, boolean shadow) {
		this.text = text;
		this.shadow = shadow;
	}

	public TrainPromptPacket(class_2540 buffer) {
		text = buffer.method_10808();
		shadow = buffer.readBoolean();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10805(text);
		buffer.writeBoolean(shadow);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> this::apply));
		return true;
	}

	@Environment(EnvType.CLIENT)
	public void apply() {
		TrainHUD.currentPrompt = text;
		TrainHUD.currentPromptShadow = shadow;
		TrainHUD.promptKeepAlive = 30;
	}

}
