package com.simibubi.create.content.trains.schedule;

import java.util.List;

import javax.annotation.Nullable;

import com.google.common.collect.ImmutableList;
import com.simibubi.create.foundation.gui.ModularGuiLineBuilder;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Pair;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_332;

public interface IScheduleInput {

	public abstract Pair<class_1799, class_2561> getSummary();

	public abstract class_2960 getId();

	public abstract class_2487 getData();

	public abstract void setData(class_2487 data);

	public default int slotsTargeted() {
		return 0;
	}

	public default List<class_2561> getTitleAs(String type) {
		class_2960 id = getId();
		return ImmutableList
			.of(Components.translatable(id.method_12836() + ".schedule." + type + "." + id.method_12832()));
	}

	public default class_1799 getSecondLineIcon() {
		return class_1799.field_8037;
	}

	public default void setItem(int slot, class_1799 stack) {}

	public default class_1799 getItem(int slot) {
		return class_1799.field_8037;
	}

	@Nullable
	public default List<class_2561> getSecondLineTooltip(int slot) {
		return null;
	}

	@Environment(EnvType.CLIENT)
	public default void initConfigurationWidgets(ModularGuiLineBuilder builder) {};

	@Environment(EnvType.CLIENT)
	public default boolean renderSpecialIcon(class_332 graphics, int x, int y) {
		return false;
	}

}
