package com.simibubi.create.content.trains.schedule;

import com.simibubi.create.foundation.gui.menu.GhostItemMenu;

import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;
import net.minecraft.class_1263;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1713;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3917;

public class ScheduleMenu extends GhostItemMenu<class_1799> {

	public boolean slotsActive = true;
	public int targetSlotsActive = 1;

	static final int slots = 2;
	public ScheduleMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	public ScheduleMenu(class_3917<?> type, int id, class_1661 inv, class_1799 contentHolder) {
		super(type, id, inv, contentHolder);
	}

	@Override
	protected ItemStackHandler createGhostInventory() {
		return new ItemStackHandler(slots);
	}

	@Override
	public void method_7593(int slotId, int dragType, class_1713 clickTypeIn, class_1657 player) {
		if (slotId != playerInventory.field_7545 || clickTypeIn == class_1713.field_7795)
			super.method_7593(slotId, dragType, clickTypeIn, player);
	}

	@Override
	protected boolean allowRepeats() {
		return true;
	}

	@Override
	protected class_1799 createOnClient(class_2540 extraData) {
		return extraData.method_10819();
	}

	@Override
	protected void addSlots() {
		addPlayerSlots(46, 140);
		for (int i = 0; i < slots; i++)
			method_7621(new InactiveItemHandlerSlot(ghostInventory, i, i, 54 + 20 * i, 88));
	}

	@Override
	protected void addPlayerSlots(int x, int y) {
		for (int hotbarSlot = 0; hotbarSlot < 9; ++hotbarSlot)
			this.method_7621(new InactiveSlot(playerInventory, hotbarSlot, x + hotbarSlot * 18, y + 58));
		for (int row = 0; row < 3; ++row)
			for (int col = 0; col < 9; ++col)
				this.method_7621(new InactiveSlot(playerInventory, col + row * 9 + 9, x + col * 18, y + row * 18));
	}

	@Override
	protected void saveData(class_1799 contentHolder) {}

	@Override
	public boolean method_7597(class_1657 player) {
		return playerInventory.method_7391() == contentHolder;
	}

	class InactiveSlot extends class_1735 {

		public InactiveSlot(class_1263 pContainer, int pIndex, int pX, int pY) {
			super(pContainer, pIndex, pX, pY);
		}

		@Override
		public boolean method_7682() {
			return slotsActive;
		}

	}

	class InactiveItemHandlerSlot extends SlotItemHandler {
private int targetIndex;

		public InactiveItemHandlerSlot(ItemStackHandler itemHandler, int targetIndex, int index, int xPosition,
			int yPosition) {
			super(itemHandler, index, xPosition, yPosition);
			this.targetIndex = targetIndex;
		}

		@Override
		public boolean method_7682() {
			return slotsActive && targetIndex < targetSlotsActive;
		}

	}

}
