package com.simibubi.create.content.trains.signal;

import com.simibubi.create.content.trains.graph.DimensionPalette;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2586;
import net.minecraft.class_5321;

public abstract class SingleBlockEntityEdgePoint extends TrackEdgePoint {

	public class_5321<class_1937> blockEntityDimension;
	public class_2338 blockEntityPos;

	public class_2338 getBlockEntityPos() {
		return blockEntityPos;
	}
	
	public class_5321<class_1937> getBlockEntityDimension() {
		return blockEntityDimension;
	}

	@Override
	public void blockEntityAdded(class_2586 blockEntity, boolean front) {
		this.blockEntityPos = blockEntity.method_11016();
		this.blockEntityDimension = blockEntity.method_10997()
			.method_27983();
	}

	@Override
	public void blockEntityRemoved(class_2338 blockEntityPos, boolean front) {
		removeFromAllGraphs();
	}

	@Override
	public void invalidate(class_1936 level) {
		invalidateAt(level, blockEntityPos);
	}

	@Override
	public boolean canMerge() {
		return false;
	}

	@Override
	public void read(class_2487 nbt, boolean migration, DimensionPalette dimensions) {
		super.read(nbt, migration, dimensions);
		if (migration)
			return;
		blockEntityPos = class_2512.method_10691(nbt.method_10562("TilePos"));
		blockEntityDimension = dimensions.decode(nbt.method_10545("TileDimension") ? nbt.method_10550("TileDimension") : -1);
	}

	@Override
	public void write(class_2487 nbt, DimensionPalette dimensions) {
		super.write(nbt, dimensions);
		nbt.method_10566("TilePos", class_2512.method_10692(blockEntityPos));
		nbt.method_10569("TileDimension", dimensions.encode(blockEntityDimension));
	}

}
