package com.simibubi.create.content.trains.track;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;

import io.github.fabricators_of_create.porting_lib.block.CustomLandingEffectsBlock;
import io.github.fabricators_of_create.porting_lib.block.CustomRunningEffectsBlock;
import net.fabricmc.fabric.api.registry.LandPathNodeTypesRegistry;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2343;
import net.minecraft.class_2350;
import net.minecraft.class_2464;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3726;
import net.minecraft.class_5819;
import net.minecraft.class_7;

public class FakeTrackBlock extends class_2248 implements class_2343, ProperWaterloggedBlock, CustomLandingEffectsBlock, CustomRunningEffectsBlock {

	public FakeTrackBlock(class_2251 p_49795_) {
		super(p_49795_.method_9640()
			.method_9634()
			.method_22488());
		method_9590(method_9564().method_11657(WATERLOGGED, false));
		LandPathNodeTypesRegistry.register(this, class_7.field_17, null);
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		return class_259.method_1073();
	}

	@Override
	public class_2464 method_9604(class_2680 pState) {
		return class_2464.field_11456;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> pBuilder) {
		super.method_9515(pBuilder.method_11667(WATERLOGGED));
	}

	@Override
	public class_2680 method_9605(class_1750 pContext) {
		return withWater(super.method_9605(pContext), pContext);
	}

	@Override
	public class_2680 method_9559(class_2680 pState, class_2350 pDirection, class_2680 pNeighborState,
		class_1936 pLevel, class_2338 pCurrentPos, class_2338 pNeighborPos) {
		updateWater(pLevel, pState, pCurrentPos);
		return pState;
	}

	@Override
	public class_3610 method_9545(class_2680 pState) {
		return fluidState(pState);
	}

	@Override
	public void method_9514(class_2680 pState, class_3218 pLevel, class_2338 pPos, class_5819 pRandom) {
		if (pLevel.method_8321(pPos) instanceof FakeTrackBlockEntity be)
			be.randomTick();
	}

	public static void keepAlive(class_1936 level, class_2338 pos) {
		if (level.method_8321(pos) instanceof FakeTrackBlockEntity be)
			be.keepAlive();
	}

	@Override
	public class_2586 method_10123(class_2338 pPos, class_2680 pState) {
		return AllBlockEntityTypes.FAKE_TRACK.create(pPos, pState);
	}

	@Override
	public boolean addLandingEffects(class_2680 state1, class_3218 level, class_2338 pos, class_2680 state2,
		class_1309 entity, int numberOfParticles) {
		return true;
	}

	@Override
	public boolean addRunningEffects(class_2680 state, class_1937 level, class_2338 pos, class_1297 entity) {
		return true;
	}

}
