package com.simibubi.create.content.trains.track;

import com.simibubi.create.AllTags;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class PlaceExtendedCurvePacket extends SimplePacketBase {

	boolean mainHand;
	boolean ctrlDown;

	public PlaceExtendedCurvePacket(boolean mainHand, boolean ctrlDown) {
		this.mainHand = mainHand;
		this.ctrlDown = ctrlDown;
	}

	public PlaceExtendedCurvePacket(class_2540 buffer) {
		mainHand = buffer.readBoolean();
		ctrlDown = buffer.readBoolean();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeBoolean(mainHand);
		buffer.writeBoolean(ctrlDown);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			class_1799 stack = sender.method_5998(mainHand ? class_1268.field_5808 : class_1268.field_5810);
			if (!AllTags.AllBlockTags.TRACKS.matches(stack) || !stack.method_7985())
				return;
			class_2487 tag = stack.method_7969();
			tag.method_10556("ExtendCurve", true);
			stack.method_7980(tag);
		});
		return true;
	}

}
