package com.simibubi.create.content.trains.track;

import com.simibubi.create.foundation.mixin.fabric.GuiAccessor;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1041;
import net.minecraft.class_124;
import net.minecraft.class_1934;
import net.minecraft.class_310;
import net.minecraft.class_329;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_5250;

public class TrackPlacementOverlay {

	@Environment(EnvType.CLIENT)
	public static void renderOverlay(class_329 gui, class_332 graphics) {
		class_310 mc = class_310.method_1551();
		if (mc.field_1690.field_1842 || mc.field_1761.method_2920() == class_1934.field_9219)
			return;
		if (TrackPlacement.hoveringPos == null)
			return;
		if (TrackPlacement.cached == null || TrackPlacement.cached.curve == null || !TrackPlacement.cached.valid)
			return;
		if (TrackPlacement.extraTipWarmup < 4)
			return;

		if (((GuiAccessor) gui).getToolHighlightTimer() > 0)
			return;

		boolean active = mc.field_1690.field_1867.method_1434();
		class_5250 text = Lang.translateDirect("track.hold_for_smooth_curve", Components.keybind("key.sprint")
			.method_27692(active ? class_124.field_1068 : class_124.field_1080));

		class_1041 window = mc.method_22683();
		int x = (window.method_4486() - gui.method_1756()
			.method_27525(text)) / 2;
		int y = window.method_4502() - 61;
		Color color = new Color(0x4ADB4A).setAlpha(class_3532.method_15363((TrackPlacement.extraTipWarmup - 4) / 3f, 0.1f, 1));
		graphics.method_51439(gui.method_1756(), text, x, y, color.getRGB(), false);
	}

}
