package com.simibubi.create.foundation.blockEntity.renderer;

import net.minecraft.class_2246;
import net.minecraft.class_2586;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_827;

public abstract class SafeBlockEntityRenderer<T extends class_2586> implements class_827<T> {
	@Override
	public final void method_3569(T be, float partialTicks, class_4587 ms, class_4597 bufferSource, int light,
		int overlay) {
		if (isInvalid(be))
			return;
		renderSafe(be, partialTicks, ms, bufferSource, light, overlay);
	}

	protected abstract void renderSafe(T be, float partialTicks, class_4587 ms, class_4597 bufferSource, int light,
		int overlay);

	public boolean isInvalid(T be) {
		return !be.method_11002() || be.method_11010()
			.method_26204() == class_2246.field_10124;
	}
}
