package com.simibubi.create.foundation.mixin.fabric;

import net.minecraft.class_2960;
import net.minecraft.class_3218;
import net.minecraft.class_3499;
import net.minecraft.class_4525;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(value = class_4525.class, priority = 900) // apply before FAPI, run earlier
public class StructureUtilsMixin {
	/**
	 * this is what vanilla and forge do, but FAPI forces a different system
	 * @see StructureTestUtilMixin
 	 */
	@Inject(method = "getStructureTemplate", at = @At("HEAD"), cancellable = true)
	private static void useStructureManager(String name, class_3218 level, CallbackInfoReturnable<class_3499> cir) {
		class_2960 id = new class_2960(name);
		level.method_14183().method_15094(id).ifPresent(cir::setReturnValue);
	}
}
