package com.simibubi.create.foundation.utility;

import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2512;

public class BlockFace extends Pair<class_2338, class_2350> {

	public BlockFace(class_2338 first, class_2350 second) {
		super(first, second);
	}

	public boolean isEquivalent(BlockFace other) {
		if (equals(other))
			return true;
		return getConnectedPos().equals(other.getPos()) && getPos().equals(other.getConnectedPos());
	}

	public class_2338 getPos() {
		return getFirst();
	}

	public class_2350 getFace() {
		return getSecond();
	}

	public class_2350 getOppositeFace() {
		return getSecond().method_10153();
	}

	public BlockFace getOpposite() {
		return new BlockFace(getConnectedPos(), getOppositeFace());
	}

	public class_2338 getConnectedPos() {
		return getPos().method_10093(getFace());
	}

	public class_2487 serializeNBT() {
		class_2487 compoundNBT = new class_2487();
		compoundNBT.method_10566("Pos", class_2512.method_10692(getPos()));
		NBTHelper.writeEnum(compoundNBT, "Face", getFace());
		return compoundNBT;
	}

	public static BlockFace fromNBT(class_2487 compound) {
		return new BlockFace(class_2512.method_10691(compound.method_10562("Pos")),
			NBTHelper.readEnum(compound, "Face", class_2350.class));
	}

}
