package com.simibubi.create.infrastructure.command;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.arguments.FloatArgumentType;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.AllPackets;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_3222;

public class CameraDistanceCommand {

	public static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("camera")
				.then(class_2170.method_9247("reset")
						.executes(ctx -> {
							class_3222 player = ctx.getSource().method_9207();
							AllPackets.getChannel().sendToClient(
									new SConfigureConfigPacket(SConfigureConfigPacket.Actions.zoomMultiplier.name(), "1"),
									player
							);

							return Command.SINGLE_SUCCESS;
						})
				).then(class_2170.method_9244("multiplier", FloatArgumentType.floatArg(0))
						.executes(ctx -> {
							float multiplier = FloatArgumentType.getFloat(ctx, "multiplier");
							class_3222 player = ctx.getSource().method_9207();
							AllPackets.getChannel().sendToClient(
									new SConfigureConfigPacket(SConfigureConfigPacket.Actions.zoomMultiplier.name(), String.valueOf(multiplier)),
									player
							);

							return Command.SINGLE_SUCCESS;
						})
				);
	}

}
