package com.simibubi.create.infrastructure.command;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_3222;

public abstract class ConfigureConfigCommand {

	protected final String commandLiteral;

	ConfigureConfigCommand(String commandLiteral) {
		this.commandLiteral = commandLiteral;
	}

	ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247(this.commandLiteral)
			.requires(cs -> cs.method_9259(0))
			.then(class_2170.method_9247("on")
				.executes(ctx -> {
					class_3222 player = ctx.getSource()
						.method_9207();
					sendPacket(player, String.valueOf(true));

					return Command.SINGLE_SUCCESS;
				}))
			.then(class_2170.method_9247("off")
				.executes(ctx -> {
					class_3222 player = ctx.getSource()
						.method_9207();
					sendPacket(player, String.valueOf(false));

					return Command.SINGLE_SUCCESS;
				}))
			.executes(ctx -> {
				class_3222 player = ctx.getSource()
					.method_9207();
				sendPacket(player, "info");

				return Command.SINGLE_SUCCESS;
			});
	}

	protected abstract void sendPacket(class_3222 player, String option);
}
