package com.simibubi.create.infrastructure.command;

import com.simibubi.create.AllSpecialTextures;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_259;
import net.minecraft.class_310;

public class HighlightPacket extends SimplePacketBase {

	private final class_2338 pos;

	public HighlightPacket(class_2338 pos) {
		this.pos = pos;
	}

	public HighlightPacket(class_2540 buffer) {
		this.pos = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(pos);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> {
			performHighlight(pos);
		}));
		return true;
	}

	@Environment(EnvType.CLIENT)
	public static void performHighlight(class_2338 pos) {
		if (class_310.method_1551().field_1687 == null || !class_310.method_1551().field_1687.method_8477(pos))
			return;

		CreateClient.OUTLINER.showAABB("highlightCommand", class_259.method_1077()
				.method_1107()
				.method_996(pos), 200)
				.lineWidth(1 / 32f)
				.colored(0xEeEeEe)
				// .colored(0x243B50)
				.withFaceTexture(AllSpecialTextures.SELECTION);
	}

}
