package com.simibubi.create.infrastructure.data;

import java.util.Set;
import java.util.concurrent.CompletableFuture;
import net.minecraft.class_7225;
import net.minecraft.class_7784;
import net.minecraft.class_7877;
import net.minecraft.class_7877.class_7882;
import net.minecraft.class_7924;
import com.simibubi.create.AllDamageTypes;
import com.simibubi.create.Create;
import com.simibubi.create.infrastructure.worldgen.AllBiomeModifiers;
import com.simibubi.create.infrastructure.worldgen.AllConfiguredFeatures;
import com.simibubi.create.infrastructure.worldgen.AllPlacedFeatures;

import io.github.fabricators_of_create.porting_lib.data.DatapackBuiltinEntriesProvider;

public class GeneratedEntriesProvider extends DatapackBuiltinEntriesProvider {
	@SuppressWarnings({ "rawtypes", "unchecked" }) // fabric: biome modifiers not a registry
	private static final class_7877 BUILDER = new class_7877()
			.method_46777(class_7924.field_42534, AllDamageTypes::bootstrap)
			.method_46777(class_7924.field_41239, (class_7882) AllConfiguredFeatures::bootstrap)
			.method_46777(class_7924.field_41245, AllPlacedFeatures::bootstrap);

	public GeneratedEntriesProvider(class_7784 output, CompletableFuture<class_7225.class_7874> registries) {
		super(output, registries, BUILDER, Set.of(Create.ID));
	}

	@Override
	public String method_10321() {
		return "Create's Generated Registry Entries";
	}
}
