package com.simibubi.create.infrastructure.worldgen;

import java.util.function.Predicate;
import net.fabricmc.fabric.api.biome.v1.BiomeModifications;
import net.fabricmc.fabric.api.biome.v1.BiomeSelectionContext;
import net.fabricmc.fabric.api.biome.v1.BiomeSelectors;
import net.minecraft.class_2893.class_2895;
import net.minecraft.class_5321;
import net.minecraft.class_6796;

public class AllBiomeModifiers {
	public static void bootstrap() {
		Predicate<BiomeSelectionContext> isOverworld = BiomeSelectors.foundInOverworld();
		Predicate<BiomeSelectionContext> isNether = BiomeSelectors.foundInTheNether();

		addOre(isOverworld, AllPlacedFeatures.ZINC_ORE);
		addOre(isOverworld, AllPlacedFeatures.STRIATED_ORES_OVERWORLD);
		addOre(isNether, AllPlacedFeatures.STRIATED_ORES_NETHER);
	}

	private static void addOre(Predicate<BiomeSelectionContext> test, class_5321<class_6796> feature) {
		BiomeModifications.addFeature(test, class_2895.field_13176, feature);
	}
}
